C     3/31/2000
      SUBROUTINE ITERATE(ITI,NITI,DELTA,MO,LO,VARNEW,op,
     +nnring,NOVAR,ITIF)
      INCLUDE 'fgraph.fi'
      INCLUDE 'fgraph.fd'
      COMMON/COITER/ AITI(3), VAR(3), PAR(10), VAROLD(10), AITIOLD(10),
     +isave(5),BEGVAR
C     PASSED AS (ITI,NITI,ITI,OP(40),NNRING,NOVAR,ITIF)
C     ITI VARIES FROM 1 TO 3 DEPENDING UPON WHICH AITI IS BEING CALCULATED
C     AITI(3) MEAN SQUARE
C     VAR(ITI) IS VALUE OF VARIABLE BEING USED FOR EACH ITI
C     PAR(1) MAX VALUE OF PARAMETER
C     PAR(2) MIN VALUE OF PARAMETER
C     PAR(3) STEP SIZE TO BEGIN ITERATION
C     PAR(4) STEP SIZE TO TERMINATE ITERATION (TAU)
C     PAR(5) MINIMUM VARIANCE DIFFERENCE TO TERMINATE ITERATION
C     OP(11) and (12) SHOULD BE 0 WITH ITERATION
C     OP(13) IS 1 WHEN ITERATING
C     OP(14) VARIABLE TYPE TO COMPARE (p,rmc,rmt,grc,gc,prp,upt,pcmb)
C     OP(15) ARRAY SEQUENCE NUMBER TO COMPARE
C     OP(16) CONTROL (ring width,cell numbers,cell sizes,wall thickness,all)
C     OP(17) STATISTIC TO CONTROL (mean res, sd res,mean+sd res)
C     OP(18) MAXIMUM NUMBER OF ITERATIONS THAT ARE ALLOWED
C     DELTA IS STEP SIZE AT EACH ITERATION
C     MO IS SET TO 1 THE FIRST TIME NEITHER VAR(1) OR VAR(3) < VAR(2)
C     VARNEW IS VALUE OF CHANGED PARAMETER
C     VAROLD(10) IS VARIABLE VALUES FOR WHICH VARIANCE WAS CALCULATED
C     AITIOLD(10) IS VARIANCE ASSOCIATED WITH EACH VARIABLE
C     NOVAR IS NUMBER OF VARIABLES FOR WHICH VALUES HAVE BEEN SAVED
C     ITIF IS FLAG FOR NUMBER OF VALUES OBTAINED - WHEN 3, COMPARES THEM
	INTEGER op(40)
c  First time through program
c*************************************************************
c* Set parameters to corret values.  Delat set to increasing *
c*************************************************************
      IF(ITI.EQ.2)THEN     !first time through
        ITIF=1
        DO 3 I=1,10
3       VAROLD(I)=0
        NOVAR=0
        LO=0
        MO=0
        VMAX=PAR(1)        !maximum value of parameter to iterate
        VMIN=PAR(2)        !minimum value of parameter to iterate
        DELTA=PAR(3)       !delta - increment or decrement value
        TAU=PAR(4)         !minimum value of delta to stop iteration
        VAR(2)=VARNEW      !sets VAR(2) to initial value of parameter
        NITI=1             !sets number of iteration to 1
        ITI=1              !begins by testing side 1
c******************************************************************************
c* Are parameters within limits? If not, describe condition and exit program. *
c******************************************************************************
1       IF(VAR(2)+DELTA.GT.VMAX.OR.VAR(2)-DELTA.LT.VMIN)THEN
          WRITE(*,'('' Use smaller Min, larger Max, or smaller Delta.''
     .    /'' First iteration could not be completed.''/
     .    '' Varb. Value: '',E10.5,''  Delta:'',E10.5,'' Min and Max:''
     .    ,2E10.5)')VAR(2),DELTA,VMIN,VMAX
          WRITE(52,'('' Use smaller Min, larger Max, or smaller Delta.''
     .    /'' First iteration could not be completed.''/
     .    '' Varb. Value: '',E10.5,''  Delta:'',E10.5,'' Min and Max:''
     .    ,2E10.5)')VAR(2),DELTA,VMIN,VMAX
          ITI=5
          GOTO 100 ! First iteration could not be completed!  Exit program.
        ELSE                    !delta is within bounds
c**********************************************************************
c* Is variance 0 or less? If so, describe condition and exit program. *
c**********************************************************************
          IF(AITI(2).LE.0)THEN
            WRITE(52,'('' Variance is 0 or less.  Stop iteration.'')')
            WRITE(*,'('' Variance is 0 or less.  Stop iteration.'')')
            ITI=5
            GOTO 100
          ENDIF
c*********************************************************************
c* Running interation. Describes parameters used in running program. *
c*********************************************************************
          VARNEW=VAR(2)-DELTA      !changes value of variable by delta
c******************************************************************************
c* Are parameters within limits? If not, describe condition and exit program. *
c******************************************************************************
          VAR(ITI)=VARNEW          !sets VAR(1 or 3) to that value
          WRITE(52,'(/'' VMAX: '',E12.6,'' VMIN: '',E12.6,'' DELTA: '',
     +    E12.6/'' MIN DELTA: '',E12.6,'' VARS(1,2): '',2(E12.6,1x))')
     +    VMAX,VMIN,DELTA,TAU,VAR(1),VAR(2)
          WRITE(*,'(/'' VMAX: '',E12.6,'' VMIN: '',E12.6,'' DELTA: '',
     +    E12.6/'' MIN DELTA: '',E12.6,'' VARS(1,2): '',2(E12.6,1x))')
     +    VMAX,VMIN,DELTA,TAU,VAR(1),VAR(2)
          RETURN !FIRST ITERATION. ITI=1 returnes to obtain variances
        ENDIF
      ENDIF  ! AITI(1) and AITI(2) have been calculated. 
      IF(NITI.EQ.1)BEGVAR=AITI(2)
40    ITIF=ITIF+1
      IF(ITIF.GT.2)GOTO 2
      IF(LO.EQ.0.OR.MO.GT.0)THEN  !BEGINNING ITERATION OR DELTA DECREASING
c****************************************************************************
c* Calculates maximum side if delta is decreasing. This complication not in * 
c*   flow diagram.                                                          *
c****************************************************************************
        IF(ITI.EQ.1)THEN
          ITI=3
          VARNEW=VAR(2)+DELTA
          IF(NOVAR.GT.0)THEN   ! DELTA IS DECREASING
            CALL FINDITI(NOVAR,VARNEW,VAROLD,AITIOLD,
     .      VAR,AITI,NFOUND,ITI)
            IF(NFOUND.EQ.1)THEN
c**************************************************************************
c* Check whether parameter was used in prior step of iteration and inform * 
c*   if it was used.                                                      *
c**************************************************************************
               WRITE(52,'('' VARIABLE '',E12.6,'' FOUND # 1''/
     .         '' ITI:'',I2)')VAR(ITI),ITI
               WRITE(*,'('' VARIABLE '',E12.6,'' FOUND # 1''/
     .         '' ITI:'',I2)')VAR(ITI),ITI
               GOTO 2
            ENDIF
          ENDIF                ! DELTA IS INCREASING
          IF(VARNEW.GE.VMAX)THEN
c********************************************************************************
c* Is central value + delta within maximum limit? If not set variable at limit. *
c********************************************************************************
            VARNEW=VMAX
c*****************************************************************************
c* Are parameters within limits? If not, describe condition but in this case *
c*   continue.                                                               *
c*****************************************************************************
            IF(VAR(2).LE.VARNEW)THEN
              WRITE(52,'('' Maximum limit = or < central value.'')')
              WRITE(*,'('' Maximum limit = or < central value.'')')
              AITI(3)=AITI(2)
              GOTO 2
            ENDIF
          ENDIF                ! VAR(3) IS OK AND DELTA INCREASING
          VAR(3)=VARNEW
          RETURN
        ELSE ! ITI IS 3
          IF(NOVAR.EQ.0)GOTO 6 ! FIRST ITERATION AND DELTA INCREASING
          ITI=1         !  DELTA IS DECREASING
          VARNEW=VAR(2)-DELTA
          CALL FINDITI(NOVAR,VARNEW,VAROLD,AITIOLD,
     .    VAR,AITI,NFOUND,ITI)
c*****************************************************************************
c* Check whether parameter was used in prior step of iteration and inform if *
c*    it was used.                                                           *
c*****************************************************************************
          IF(NFOUND.EQ.1)THEN
            WRITE(52,'('' VARIABLE '',E12.6,'' FOUND # 2''/
     .      '' ITI:'',I2)')VAR(ITI),ITI
            WRITE(*,'('' VARIABLE '',E12.6,'' FOUND # 2''/
     .      '' ITI:'',I2)')VAR(ITI),ITI
            GOTO 2
          ENDIF
          RETURN
        ENDIF
6       DO 4 I=1,3      ! ONLY FOR FIRST ITERATION. SAVE VARIANCES 1-3.
        VAROLD(I)=VAR(I)
4       AITIOLD(I)=AITI(I)
        NOVAR=3         ! FIRST ITERATION COMPLETE AND VALUES SAVED.
      ENDIF
C  ALL NEEDED VALUES HAVE BEEN CALCULATED
2     LO=0
c*****************************************
c* Write and display various statistics. *
c*****************************************
      IF(ICOUNT.EQ.4)THEN
	  CALL clearscreen($gclearscreen)
	  icount=1
	END IF
      WRITE(52,'(/'' Iteration'',I4,''  Delta = '',E12.6,
     +  ''   Min Delta: '',E12.6/
     +  '' Varb values 1-3: '',3(E12.6,1x)/'' Mean/MS 1-3: '',
     +  3(E12.6,1x),'' Complete ring pairs: '',I3)')NITI,DELTA,TAU,
     +  (VAR(I),I=1,3),(AITI(I), I=1,3),nnring
      WRITE(*,'(/'' Iteration'',I4,''  Delta = '',E12.6,
     +  ''   Min Delta: '',E12.6/
     +  '' Varb values 1-3 '',3(E12.6,1x)/'' Mean/MS 1-3 '',
     +  3(E12.6,1x),'' Complete ring pairs: '',I3)')NITI,DELTA,TAU,
     +  (VAR(I),I=1,3),(AITI(I), I=1,3),nnring
      icount=icount+1
      KK=0
c******************************************************************************
c* Are parameters within limits? If not, describe condition and exit program. *
c******************************************************************************
      DO 30 K=1,3,2
        IF(AITI(K).GE.AITI(2))GOTO 30 ! Skip to end if equal or larger
        IF(AITI(K).LE.0)THEN  ! Flags that variance is negative
          WRITE(52,'('' Variance is zero or negative.'')')
          WRITE(*,'('' Variance is zero or negative.'')')
          ITI=5
          GOTO 100    ! Exits as error
        ENDIF         ! Variance is positive
        IF(KK.EQ.1)THEN    ! Variances on each side of mid point are lower
          IF(MO.EQ.0)THEN
            WRITE(*,'('' Variances + Delta and - Delta are less than '',
     +      ''variances at mid point.''/'' Delta increasing. '')')
            WRITE(52,'('' Variances + Delta and - Delta are less than ''
     +      ,''variances at mid point.''/'' Delta increasing.'')')
c*****************************************************************************
c* Are parameters within limits? Warning of this condition and asks "if want *
c*   to quit or select lowest variance and continue program?"                *                                      *
c*****************************************************************************
            Write(*,'('' CONVERGENCE REQUIRES A DECISION!'' /
     +      '' Enter 1 to decrease variable, enter 3 to increase''/
     +      '' variable or enter 0 to stop iteration. 0 '',\)')
            Read(*,'(I1)')J
            IF(J.EQ.1.OR.J.EQ.3)THEN
               IF(J.EQ.1)THEN
                 NEWK=1
                 ITI=1
                 GOTO 30 ! Variable was saved already, go to loop end
               ELSE
                 NEWK=3
                 ITI=3
                 NOVAR=NOVAR-1
                 GOTO 29 ! Variable not saved, overwrite other then exit loop
               ENDIF
            ELSE
              ITI=5
              GOTO 100   ! Exits with error
            ENDIF
          ELSE
            WRITE(52,'('' Variances + Delta and - Delta are less than ''
     +      ,''variances at mid point.''/'' Delta decreasing.'',
     +      '' CONVERGENCE POSSIBLE EITHER WAY.  Select direction.''/)')
            WRITE(*,'('' Variances + Delta and - Delta are less than '',
     +      ''variances at mid point.''/'' Delta decreasing. '',
     +      '' CONVERGENCE POSSIBLE EITHER WAY.''/'' Enter 1 to '',
     +      '' decrease variable, 3 to increase variable''/
     +      '' or enter 0 to stop iteration. 0 '',\)')
            READ(*,'(I1)')J
            IF(J.EQ.1)THEN
              NEWK=1
              ITI=1
              GOTO 30
            ELSE IF(J.EQ.3)THEN
              NEWK=3
              ITI=3
              GOTO 30
            ELSE  
              ITI=4
              GOTO 998   ! Exits normally 
            ENDIF
          ENDIF
        ENDIF  !KK NOT EQUAL, Variances on each side of mid value are OK 
        LO=-1 ! Only one variance is less than mid point variance
        KK=K  ! Provides a value for checking above
        NEWK=K  ! NEWK is either 1 or 3 depending on
        ITI=K
29      IF(MO.EQ.0.AND.NOVAR.LT.10)THEN !Do up to 10 only if delta increasing
c*****************************************************************************
c* Saves variance of up to 10 steps when delta is increaing so if used again * 
c*   the variance can be read from a file rather than recalculating it.      *
c*****************************************************************************
          IF(NOVAR.EQ.0)THEN
            NOVAR=1                ! Sets counter to 1
            VAROLD(NOVAR)=VAR(2)   ! Saves central value
            AITIOLD(NOVAR)=AITI(2) ! Saves variance of central value
          ENDIF
          NOVAR=NOVAR+1            ! Increments counter of variables saved
          VAROLD(NOVAR)=VAR(NEWK)  ! Saves variable value
          AITIOLD(NOVAR)=AITI(NEWK)! Saves variance associated with variable
        ENDIF
30    CONTINUE
      NITI=NITI+1            ! Increase the number for the next iteration
c**********************************************************************************************
c* Is average variance differenc less than criticle value?  If so, the condition is described *
c*   and user is given choice to terminate program or run it again with new values.           *
c**********************************************************************************************
      IF(ABS((AITI(1)+AITI(3))/2-AITI(2)).LT.PAR(5))THEN!Varinc diff too small
        WRITE(52,'('' Average difference in variance: '',E12.6,
     +  '' is < criticle value: '',E12.6/'' Iteration terminated.'')')
     +  ABS((AITI(1)+AITI(3))/2-AITI(2)),PAR(5)
        WRITE(*,'('' Average difference in variance: '',E12.6,
     +  '' is < criticle value: '',E12.6/'' Iteration terminated.'')')
     +  ABS((AITI(1)+AITI(3))/2-AITI(2)),PAR(5)
        GOTO 999 ! Terminates iteration but allows user to accept results
      ENDIF  ! Variance difference large enough
c******************************************************************************
c* Is the number of iterations equal to or smaller than criticle value? If so,*
c*  describe condition and exit with option to run program with new values.   *
c******************************************************************************
      IF(NITI.LE.OP(18)) GOTO 33 ! Checks if too many iterations
      WRITE(52,'(/'' ITERATIONS EXCEED LIMIT ASSIGNED- NOT CONVERGING!''
     . )')
      WRITE(*,'(/'' ITERATIONS EXCEED LIMIT ASSIGNED - NOT CONVERGING!''
     . )')
      GOTO 999
33    IF(LO.LT.0)THEN  ! ONE VARIANCE DIFFERENCE WAS LOWER THAN MID VALUE
C       MOVE VARIABLE VALUE AND ITS VARIANCE TO CENTRAL VALUE
45      VAR(2)=VAR(NEWK)      !  Changes central values
        AITI(2)=AITI(NEWK)    !  Copies variance for new central value
      ELSE
        MO=1
      ENDIF
c**************************************
c* Is delta increasing or decreasing? *
c**************************************
35    IF(MO.GT.0)GOTO 37   ! GO TO 37 IF DELTA IS DECREASING
c****************************************************************************
C* Double the value of delta. Replace variance of central to minimum value. *
c****************************************************************************
      ITIF=2
      DELTA=2.*DELTA           ! Calculates new increment (departure)
c**************************************************************************
c* Is delta equal to or smaller than criticle value? If so, describe      *
c* condition and exit program with option to run program with new values. *
c**************************************************************************
11    IF(DELTA.LT.TAU)GOTO 999 ! Checks if increment is too small
12    IF(ITI.EQ.1)THEN         ! For new value on minimum (lower) side
        VARNEW=VAR(2)-DELTA    ! Calculates value for lower side
        IF(VARNEW.LE.VMIN)THEN ! Checks if it is too small
          VARNEW=VMIN          ! If too small sets it to minimum value
          IF(VARNEW.EQ.VAR(2))THEN  ! Checks if min is same as central value
            GOTO 38                 ! If it is, exits program with error
          ENDIF
          MO=1      ! Since minimum has been reached, start halving increment
          GOTO 41   ! Check to see if we already have the variance value
        ENDIF
      ELSE                     ! For new increment on maximum (upper) side
        VARNEW=VAR(2)+DELTA    ! Calculates value on maximum side
        IF(VARNEW.GE.VMAX)THEN ! Checks if it is too large
          VARNEW=VMAX          ! If too large set it to maximum value
          IF(VARNEW.EQ.VAR(2))THEN! Checks if maximum is same as central value
            GOTO 38               ! If it is, exits program with error
          ENDIF
          MO=1    ! Since maximum has been reached, start halving increment
          GOTO 41 ! Check to see if we already have the variance value
        ENDIF
      ENDIF    ! Don't need to search past values, this is always a new value
      VAR(ITI)=VARNEW ! Enter the value for iteration
36    RETURN
c*******************************************************************************
C*DELTA DECREASING: Calculates only minimum side, see line 40 for maximum side.*  
c* Halve delta.                                                                *
c*******************************************************************************
37    DELTA=.5*DELTA           ! Calculates new departure (increment)
c**************************************************************************
c* Is delta equal to or smaller than criticle value? If so, describe      *
c* condition and exit program with option to run program with new values. *
c**************************************************************************
      IF(DELTA.LT.TAU)GOTO 999 ! If departure too small
      ITI=1                    ! Parameter set for minimum side calculation
      ITIF=1
      VARNEW=VAR(2)-DELTA      ! Calculates minimum (lower) value
      IF(VARNEW.LE.VMIN)THEN   ! Checks if it is too small
        VARNEW=VMIN            ! If too small, set it to minimum allowed
        IF(VARNEW.EQ.VAR(2))THEN  ! If min is same as central value
          AITI(1)=AITI(2)         ! If same, use variance of central value
          VAR(1)=VARNEW           ! Sets value as don't need to calculate it
          GOTO 40                 ! Go to calculation of maximum value
        ENDIF
      ENDIF
41    IF(NOVAR.GT.0)THEN   ! DELTA IS DECREASING
        CALL FINDITI(NOVAR,VARNEW,VAROLD,AITIOLD,
     .  VAR,AITI,NFOUND,ITI) ! Checking if values have been calculated before
c******************************************************************       
c* Saves variance of up to 10 steps so if used again the variance * 
c*   can be read from a file rather than recalculating it.        *
c******************************************************************
        IF(NFOUND.EQ.1)THEN
          WRITE(52,'('' VARIABLE/MS '',2E12.6,'' FOUND # 3''/
     .    '' ITI:'',I2)')VAR(ITI),AITI(ITI),ITI
          WRITE(*,'('' VARIABLE/MS '',2E12.6,'' FOUND # 3''/
     .    '' ITI:'',I2)')VAR(ITI),AITI(ITI),ITI
          GOTO 40       ! Go to calculation of maximum (upper) value
        ENDIF
      ENDIF
      VAR(ITI)=VARNEW   ! Enters value for iteration
C   GO REPEAT ITERATION LOOP WHEN DELTA IS DECREASING
100   RETURN
c    ITI is set to 4 to indicate that Iteration was run and completed.
999   ITI=4
998   NITI=NITI-1       ! Correct number as was incremented before checking
c998   WRITE(52,'(/'' FINISHED ITERATION. Parameter '',
c     +2I3,'' optimized value:'', E12.6/
c     +'' Sq Mean or MS Residual'',E12.6,'' with'',I4,'' iterations.'',
c     +'' Diff: '',E12.6/
c     +'' Number of ring pairs without a missing ring is '',I4)')
c     +OP(14),OP(15),var(2),AITI(2),NITI,AITI(2)-BEGVAR,nnring
c      WRITE(*,'(/'' FINISHED ITERATION. Parameter '',
c     +2I3,'' optimized value:'', E12.6/
c     +'' Sq Mean or MS Residual'',E12.6,'' with'',I4,'' iterations.'',
c     +'' Diff: '',E12.6/
c     +'' Number of ring pairs without a missing ring is '',I4)')
c     +OP(14),OP(15),var(2),AITI(2),NITI,AITI(2)-BEGVAR,nnring
c *****************************************
c* Terminate normally with option to run *
c*   full simulation with new values.    *
c*****************************************
      OP(13)=0  ! Changes parameters back to running full program
	OP(11)=ISAVE(1)   !                    "
	OP(12)=ISAVE(2)
	op(10)=isave(3)
	op(5)=isave(4)
      VARNEW=VAR(2)
      GOTO 100
38    WRITE(52,'('' Mid point is at limits. Increase limits or try '',
     .''decreasing Delta.'')')
      WRITE(*,'('' Mid point is at limits. Increase limits or try '',
     .''decreasing Delta.'')')
      ITI=5
      RETURN
      END

      SUBROUTINE FINDITI(NOVAR,VARNEW,VAROLD,AITIOLD,VAR,AITI,NFOUND,
     .ITI)
      REAL VAROLD(10),AITIOLD(10),VAR(3),AITI(3)
      NFOUND=0
      DO 10 I=1,NOVAR
      IF(VARNEW.EQ.VAROLD(I))THEN
        AITI(ITI)=AITIOLD(I)
        VAR(ITI)=VAROLD(I)
        NFOUND=1
        RETURN
      ENDIF
10    CONTINUE
      RETURN
      END

      SUBROUTINE ITISETUP(NITI,MO,ITI,KCMB,OP,ISAVE)
      INTEGER op(40), kcmb(10),ISAVE(5)
      isave(1)=op(11)
      isave(2)=op(12)
	isave(3)=op(10)
	isave(4)=op(5)
      kcmb(8)=0
      op(5)=0
      op(13)=1
      op(11)=0
      op(12)=0
	op(10)=1
      mo=0
      niti=1
      iti=2
      WRITE(52,'(/''                     Begin Iteration ''/
     +'' *******************************************************'')')
      WRITE(*,'('' Begin Iteration - Please Wait for Initial Calculation
     +s!''/'' *******************************************************'')
     +')
 1    RETURN
C 2    PAUSE 'UNABLE TO OPEN ITERATE.OUT'
      END

      SUBROUTINE GETVAR(VARNEW,op,ierr)
C      Real p(60), rmc(3),rmt(3),grc(5),gc(5),prp(3),upt(5),pcmb(40) 
C      Checks validity of input and prints out the variables chosen 
C      Must add changes for op(14)= 2,3,4,5,6,7,8
      COMMON/PARMS/  p(60), pcmb(100), zini(40), den(5),piso(40),
     + rmc(3),rmt(3),grc(5),gc(5),prp(3),upt(5),xrmn(5),xrmx(5)
      INTEGER op(40)
      ierr=0
c          p,rmc,rmt,grc,gc,prp,upt,xrmn,xrmx,b,zini
      GOTO(1, 2,  3, 4,  5, 6,  7,  8,   109,110,111)op(14)
      Pause ' Option 14 out of range'
      ierr=-1
      GOTO 30
 1    IF(op(15).LT.1.OR.op(15)+op(21).GT.60)THEN !p=60
        Pause ' Option 15 out of range'
        ierr=2
      ELSE
        IF(op(21).GT.0)THEN
          VARNEW=0
          DO I=0,op(21)
            VARNEW=VARNEW+p(op(15)+I)
          ENDDO
          VARNEW=VARNEW/(op(21)+1)  
        ELSE  
          VARNEW=p(op(15))
        ENDIF
        WRITE(52,'('' p('',I2,'') = '',F12.6,'' to be averaged with''
     +  ,'' the'',I2,'' next parameters'')')op(15),VARNEW,op(21)
        WRITE(*,'('' p('',I2,'') = '',F12.6,'' to be averaged with''
     +  ,'' the'',I2,'' next parameters'')')op(15),VARNEW,op(21)
      ENDIF
      GOTO 30
 2    IF(op(15).LT.1.OR.op(15)+op(21).GT.3)THEN !rmc=3
        Pause ' Option 15 out of range'
        ierr=2
      ELSE
        IF(op(21).GT.0)THEN
          VARNEW=0
          DO I=0,op(21)
            VARNEW=VARNEW+rmc(op(15)+I)
          ENDDO
          VARNEW=VARNEW/(op(21)+1)  
        ELSE  
          VARNEW=rmc(op(15))
        ENDIF
        WRITE(52,'('' rmc('',I2,'') = '',F12.6,'' to be averaged with''
     +  ,'' the'',I2,'' next parameters'')')op(15),VARNEW,op(21)
        WRITE(*,'('' rmc('',I2,'') = '',F12.6,'' to be averaged with''
     +  ,'' the'',I2,'' next parameters'')')op(15),VARNEW,op(21)
      ENDIF
      GOTO 30
 3    IF(op(15).LT.1.OR.op(15)+op(21).GT.3)THEN !rmt=3
        Pause ' Option 15 out of range'
        ierr=3
      ELSE
       IF(op(21).GT.0)THEN
          VARNEW=0
          DO I=0,op(21)
            VARNEW=VARNEW+rmt(op(15)+I)
          ENDDO
          VARNEW=VARNEW/(op(21)+1)  
        ELSE  
          VARNEW=rmt(op(15))
        ENDIF
        WRITE(52,'('' rmt('',I2,'') = '',F12.6,'' to be averaged with''
     +  ,'' the'',I2,'' next parameters'')')op(15),VARNEW,op(21)
        WRITE(*,'('' rmt('',I2,'') = '',F12.6,'' to be averaged with''
     +  ,'' the'',I2,'' next parameters'')')op(15),VARNEW,op(21)
      ENDIF
      GOTO 30
 4    IF(op(15).LT.1.OR.op(15)+op(21).GT.5)THEN !grc=5
        Pause ' Option 15 out of range'
        ierr=4
      ELSE
       IF(op(21).GT.0)THEN
          VARNEW=0
          DO I=0,op(21)
            VARNEW=VARNEW+grc(op(15)+I)
          ENDDO
          VARNEW=VARNEW/(op(21)+1)  
        ELSE  
          VARNEW=grc(op(15))
        ENDIF
        WRITE(52,'('' grc('',I2,'') = '',F12.6,'' to be averaged with''
     +  ,'' the'',I2,'' next parameters'')')op(15),VARNEW,op(21)
        WRITE(*,'('' grc('',I2,'') = '',F12.6,'' to be averaged with''
     +  ,'' the'',I2,'' next parameters'')')op(15),VARNEW,op(21)
      ENDIF
      GOTO 30
 5    IF(op(15).LT.1.OR.op(15)+op(21).GT.5)THEN !gc=5
        Pause ' Option 15 out of range'
        ierr=5
      ELSE
       IF(op(21).GT.0)THEN
          VARNEW=0
          DO I=0,op(21)
            VARNEW=VARNEW+gc(op(15)+I)
          ENDDO
          VARNEW=VARNEW/(op(21)+1)  
        ELSE  
          VARNEW=gc(op(15))
        ENDIF
        WRITE(52,'('' gc('',I2,'') = '',F12.6,'' to be averaged with''
     +  ,'' the'',I2,'' next parameters'')')op(15),VARNEW,op(21)
        WRITE(*,'('' gc('',I2,'') = '',F12.6,'' to be averaged with''
     +  ,'' the'',I2,'' next parameters'')')op(15),VARNEW,op(21)
      ENDIF
      GOTO 30
 6    IF(op(15).LT.1.OR.op(15)+op(21).GT.3)THEN !prp
        Pause ' Option 15 out of range'
        ierr=6
      ELSE
       IF(op(21).GT.0)THEN
          VARNEW=0
          DO I=0,op(21)
            VARNEW=VARNEW+prp(op(15)+I)
          ENDDO
          VARNEW=VARNEW/(op(21)+1)  
        ELSE  
          VARNEW=prp(op(15))
        ENDIF
        WRITE(52,'('' prp('',I2,'') = '',F12.6,'' to be averaged with''
     +  ,'' the'',I2,'' next parameters'')')op(15),VARNEW,op(21)
        WRITE(*,'('' prp('',I2,'') = '',F12.6,'' to be averaged with''
     +  ,'' the'',I2,'' next parameters'')')op(15),VARNEW,op(21)
      ENDIF
      GOTO 30
 7    IF(op(15).LT.1.OR.op(15)+op(21).GT.5)THEN !upt=5
        Pause ' Option 15 out of range'
        ierr=7
      ELSE
       IF(op(21).GT.0)THEN
          VARNEW=0
          DO I=0,op(21)
            VARNEW=VARNEW+upt(op(15)+I)
          ENDDO
          VARNEW=VARNEW/(op(21)+1)  
        ELSE  
          VARNEW=upt(op(15))
        ENDIF
        WRITE(52,'('' upt('',I2,'') = '',F12.6,'' to be averaged with''
     +  ,'' the'',I2,'' next parameters'')')op(15),VARNEW,op(21)
        WRITE(*,'('' upt('',I2,'') = '',F12.6,'' to be averaged with''
     +  ,'' the'',I2,'' next parameters'')')op(15),VARNEW,op(21)
      ENDIF
      GOTO 30
 8    IF(op(15).LT.1.OR.op(15)+op(21).GT.5)THEN !XRMN(5)
        Pause ' Option 15 out of range'
        ierr=7
      ELSE
       IF(op(21).GT.0)THEN
          VARNEW=0
          DO I=0,op(21)
            VARNEW=VARNEW+XRMN(op(15)+I)
          ENDDO
          VARNEW=VARNEW/(op(21)+1)  
        ELSE  
          VARNEW=XRMN(op(15))
        ENDIF
        WRITE(52,'('' xrmn('',I2,'') = '',F12.6,'' to be averaged with''
     +  ,'' the'',I2,'' next parameters'')')op(15),VARNEW,op(21)
        WRITE(*,'('' xrmn('',I2,'') = '',F12.6,'' to be averaged with''
     +  ,'' the'',I2,'' next parameters'')')op(15),VARNEW,op(21)
      ENDIF
      GOTO 30
109   IF(op(15).LT.1.OR.op(15)+op(21).GT.5)THEN !xrmx
        Pause ' Option 15 out of range'
        ierr=7
      ELSE
       IF(op(21).GT.0)THEN
          VARNEW=0
          DO I=0,op(21)
            VARNEW=VARNEW+xrmx(op(15)+I)
          ENDDO
          VARNEW=VARNEW/(op(21)+1)  
        ELSE  
          VARNEW=xrmx(op(15))
        ENDIF
        WRITE(52,'('' xrmx('',I2,'') = '',F12.6,'' to be averaged with''
     +  ,'' the'',I2,'' next parameters'')')op(15),VARNEW,op(21)
        WRITE(*,'('' xrmx('',I2,'') = '',F12.6,'' to be averaged with''
     +  ,'' the'',I2,'' next parameters'')')op(15),VARNEW,op(21)
      ENDIF
      GOTO 30
111   IF(op(15).LT.1.OR.op(15)+op(21).GT.40)THEN !zini=40
        Pause ' Option 15 out of range'
        ierr=7
      ELSE
       IF(op(21).GT.0)THEN
          VARNEW=0
          DO I=0,op(21)
            VARNEW=VARNEW+zini(op(15)+I)
          ENDDO
          VARNEW=VARNEW/(op(21)+1)  
        ELSE  
          VARNEW=zini(op(15))
        ENDIF
        WRITE(52,'('' zini('',I2,'') = '',F12.6,'' to be averaged with''
     +  ,'' the'',I2,'' next parameters'')')op(15),VARNEW,op(21)
        WRITE(*,'('' zini('',I2,'') = '',F12.6,'' to be averaged with''
     +  ,'' the'',I2,'' next parameters'')')op(15),VARNEW,op(21)
      ENDIF
      GOTO 30
110   IF(op(15).LT.1.OR.op(15)+op(21).GT.100)THEN !
        Pause ' Option 15 out of range'
        ierr=8
      ELSE
       IF(op(21).GT.0)THEN
          VARNEW=0
          DO I=0,op(21)
            VARNEW=VARNEW+pcmb(op(15)+I)
          ENDDO
          VARNEW=VARNEW/(op(21)+1)  
        ELSE  
          VARNEW=pcmb(op(15))
        ENDIF
        WRITE(52,'('' b('',I2,'') = '',F12.6,'' to be averaged with''
     +  ,'' the'',I2,'' next parameters'')')op(15),VARNEW,op(21)
        WRITE(*,'('' b('',I2,'') = '',F12.6,'' to be averaged with''
     +  ,'' the'',I2,'' next parameters'')')op(15),VARNEW,op(21)
      ENDIF
 30   GOTO(9,10,11,12,13,24,25,26,27)op(16)
      Pause ' Option 16 out of range'
      ierr=9
      GOTO 50
  9   WRITE(52,'('' Control on Ring Width '')')
      WRITE(*,'('' Control on Ring Width '')')
      GOTO 40
 10   WRITE(52,'('' Control on Cell Numbers '')')
      WRITE(*,'('' Control on Cell Numbers '')')
      GOTO 40
 11   WRITE(52,'('' Control on Cell Sizes '')')
      WRITE(*,'('' Control on Cell Sizes '')')
      GOTO 40
 12   WRITE(52,'('' Control on Wall Thicknesses '')')
      WRITE(*,'('' Control on Wall Thicknesses '')')
      GOTO 40
 13   WRITE(52,'('' Control on Sum of all four Cell Measurements '')')
      WRITE(*,'('' Control on Sum of all four Cell Measurements '')')
      GOTO 40
 24   WRITE(52,'('' Control on Indexed Chronology '')')
      WRITE(*,'('' Control on Indexed Chronology '')')
      GOTO 40
 25   WRITE(52,'('' Control on Sum of all five Measurements '')')
      WRITE(*,'('' Control on Sum of all five Measurements '')')
          GOTO 40
 26   WRITE(52,'('' Control on Sum of Cell Size, Cell Wall Thickenss and
     + Index '')')
      WRITE(*,'('' Control on Sum of Cell Size, Cell Wall Thickenss and
     +Index '')')
          GOTO 40
 27   WRITE(52,'('' Control on Sum of Ring Width, Cell Number and '',
     +  ''Index '')')
      WRITE(*,'('' Control on Sum of Ring Width, Cell Number and '',
     +  ''Index '')')
 40   IF(op(17).EQ.0)THEN
      WRITE(52,'('' Statistic used was absolute value of the Mean of Res
     +iduals'')')
      WRITE(*,'('' Statistic used was absolute value of the Mean of Resi
     +duals'')')
      GOTO 50
      ENDIF
      GOTO(14,15,16)op(17)
      Pause ' Option 17 out of range'
      ierr=10
      GOTO 50
 14   WRITE(52,'('' Statistic used was Standard Devietion of Residuals
     ++ abs value Mean Residuals'')')
      WRITE(*,'('' Statistic used was Standard Deviation of Residuals +
     +abs value Mean Residuals'')')
      GOTO 50
 15   WRITE(52,'('' Statistic used was 1 - Correlation Squared'')')
      WRITE(*,'('' Statistic used was 1 - Correlation Squared'')')
      GOTO 50
 16   WRITE(52,'('' (Standard Deviation + abs value Mean Residuals)'',
     +''/St. Dev Y used'')')
      WRITE(*,'('' (Standard Deviation + abs value Mean Residuals)'',
     +''/St. Dev Y used'')')
 50   RETURN
      END

      SUBROUTINE CHANGE(op,ierr,ITI,VARNEW)
C     xrmn, xrmx, zini added 13/11/99 
      COMMON/PARMS/  p(60), pcmb(100), zini(40), den(5),piso(40),
     + rmc(3),rmt(3),grc(5),gc(5),prp(3),upt(5),xrmn(5),xrmx(5)
      INTEGER op(40)
      ierr=0
      AVARNEW=0
      GOTO(1,2,3,4,5,6,7,8,9,10,11)op(14)
      Pause ' Option 14 out of range'
      ierr=-1
      RETURN
 1    IF(op(15).LT.1.OR.op(15)+op(21).GT.60)THEN
        Pause ' Option 15 out of range'
        ierr=2
      ELSE
        IF(op(21).GT.0)THEN
          WRITE(*,'(I2,'' P:'',\)')ITI
          WRITE(52,'(I2,'' P:'',\)')ITI
          DO I=0,op(21)
            AVARNEW=AVARNEW+p(op(15)+I)
          ENDDO
          DIF=VARNEW-AVARNEW/(op(21)+1)  
          DO I=0,op(21) 
            p(op(15)+I)=p(op(15)+I)+DIF 
            WRITE(*,'(I3,''='',F9.4,'','',\)')op(15)+I,p(op(15)+I)
            WRITE(52,'(I3,''='',F9.4,'','',\)')op(15)+I,p(op(15)+I)
          ENDDO
          WRITE(*,'('' Av.='',F9.4)')VARNEW 
          WRITE(52,'('' Av.='',F9.4)')VARNEW 
        ELSE  
          p(op(15))=VARNEW
        ENDIF
      ENDIF
      RETURN
 2    IF(op(15).LT.1.OR.op(15).GT.3)THEN
        Pause ' Option 15 out of range'
        ierr=2
      ELSE
        IF(op(21).GT.0)THEN
          WRITE(*,'(I2,'' RMC:'',\)')ITI
          WRITE(52,'(I2,'' RMC:'',\)')ITI
          DO I=0,op(21)
            AVARNEW=AVARNEW+rmc(op(15)+I)
          ENDDO
          DIF=VARNEW-AVARNEW/(op(21)+1)  
          DO I=0,op(21) 
            rmc(op(15)+I)=rmc(op(15)+I)+DIF 
            WRITE(*,'(I3,''='',F9.4,'','',\)')op(15)+I,rmc(op(15)+I)
            WRITE(52,'(I3,''='',F9.4,'','',\)')op(15)+I,rmc(op(15)+I)
          ENDDO
          WRITE(*,'('' Av.='',F9.4)')VARNEW 
          WRITE(52,'('' Av.='',F9.4)')VARNEW 
        ELSE  
          rmc(op(15))=VARNEW
        ENDIF
      ENDIF
      RETURN
 3    IF(op(15).LT.1.OR.op(15).GT.3)THEN
        Pause ' Option 15 out of range'
        ierr=3
      ELSE
        IF(op(21).GT.0)THEN
          WRITE(*,'(I2,'' RMT:'',\)')ITI
          WRITE(52,'(I2,'' RMT:'',\)')ITI
          DO I=0,op(21)
            AVARNEW=AVARNEW+rmt(op(15)+I)
          ENDDO
          DIF=VARNEW-AVARNEW/(op(21)+1)  
          DO I=0,op(21) 
            rmt(op(15)+I)=rmt(op(15)+I)+DIF 
            WRITE(*,'(I3,''='',F9.4,'','',\)')op(15)+I,rmt(op(15)+I)
            WRITE(52,'(I3,''='',F9.4,'','',\)')op(15)+I,rmt(op(15)+I)
          ENDDO
          WRITE(*,'('' Av.='',F9.4)')VARNEW 
          WRITE(52,'('' Av.='',F9.4)')VARNEW 
        ELSE  
          rmt(op(15))=VARNEW
        ENDIF
      ENDIF
      RETURN
 4    IF(op(15).LT.1.OR.op(15).GT.5)THEN
        Pause ' Option 15 out of range'
        ierr=4
      ELSE
        IF(op(21).GT.0)THEN
          WRITE(*,'(I2,'' GRC:'',\)')ITI
          WRITE(52,'(I2,'' GRC:'',\)')ITI
          DO I=0,op(21)
            AVARNEW=AVARNEW+grc(op(15)+I)
          ENDDO
          DIF=VARNEW-AVARNEW/(op(21)+1)  
          DO I=0,op(21) 
            grc(op(15)+I)=grc(op(15)+I)+DIF 
            WRITE(*,'(I3,''='',F9.4,'','',\)')op(15)+I,grc(op(15)+I)
            WRITE(52,'(I3,''='',F9.4,'','',\)')op(15)+I,grc(op(15)+I)
          ENDDO
          WRITE(*,'('' Av.='',F9.4)')VARNEW 
          WRITE(52,'('' Av.='',F9.4)')VARNEW 
        ELSE  
          grc(op(15))=VARNEW
        ENDIF
      ENDIF
      RETURN
 5    IF(op(15).LT.1.OR.op(15).GT.5)THEN
        Pause ' Option 15 out of range'
        ierr=5
      ELSE
        IF(op(21).GT.0)THEN
          WRITE(*,'(I2,'' GC:'',\)')ITI
          WRITE(52,'(I2,'' GC:'',\)')ITI
          DO I=0,op(21)
            AVARNEW=AVARNEW+gc(op(15)+I)
          ENDDO
          DIF=VARNEW-AVARNEW/(op(21)+1)  
          DO I=0,op(21) 
            gc(op(15)+I)=gc(op(15)+I)+DIF 
            WRITE(*,'(I3,''='',F9.4,'','',\)')op(15)+I,gc(op(15)+I)
            WRITE(52,'(I3,''='',F9.4,'','',\)')op(15)+I,gc(op(15)+I)
          ENDDO
          WRITE(*,'('' Av.='',F9.4)')VARNEW 
          WRITE(52,'('' Av.='',F9.4)')VARNEW 
        ELSE  
          gc(op(15))=VARNEW
        ENDIF
      ENDIF
      RETURN
 6    IF(op(15).LT.1.OR.op(15).GT.3)THEN
        Pause ' Option 15 out of range'
        ierr=6
      ELSE
        IF(op(21).GT.0)THEN
          WRITE(*,'(I2,'' PRP:'',\)')ITI
          WRITE(52,'(I2,'' PRP:'',\)')ITI
          DO I=0,op(21)
            AVARNEW=AVARNEW+prp(op(15)+I)
          ENDDO
          DIF=VARNEW-AVARNEW/(op(21)+1)  
          DO I=0,op(21) 
            prp(op(15)+I)=prp(op(15)+I)+DIF 
            WRITE(*,'(I3,''='',F9.4,'','',\)')op(15)+I,prp(op(15)+I)
            WRITE(52,'(I3,''='',F9.4,'','',\)')op(15)+I,prp(op(15)+I)
          ENDDO
          WRITE(*,'('' Av.='',F9.4)')VARNEW 
          WRITE(52,'('' Av.='',F9.4)')VARNEW 
        ELSE  
          prp(op(15))=VARNEW
        ENDIF
      ENDIF
      RETURN
 7    IF(op(15).LT.1.OR.op(15).GT.3)THEN
        Pause ' Option 15 out of range'
        ierr=7
      ELSE
        IF(op(21).GT.0)THEN
          WRITE(*,'(I2,'' UPT:'',\)')ITI
          WRITE(52,'(I2,'' UPT:'',\)')ITI
          DO I=0,op(21)
            AVARNEW=AVARNEW+upt(op(15)+I)
          ENDDO
          DIF=VARNEW-AVARNEW/(op(21)+1)  
          DO I=0,op(21) 
            upt(op(15)+I)=upt(op(15)+I)+DIF 
            WRITE(*,'(I3,''='',F9.4,'','',\)')op(15)+I,upt(op(15)+I)
            WRITE(52,'(I3,''='',F9.4,'','',\)')op(15)+I,upt(op(15)+I)
          ENDDO
          WRITE(*,'('' Av.='',F9.4)')VARNEW 
          WRITE(52,'('' Av.='',F9.4)')VARNEW 
        ELSE  
          upt(op(15))=VARNEW
        ENDIF
      ENDIF
      RETURN
 8    IF(op(15).LT.1.OR.op(15).GT.5)THEN !xrmn(5)
        Pause ' Option 15 out of range'
        ierr=8
      ELSE
        IF(op(21).GT.0)THEN
          WRITE(*,'(I2,'' XRMN:'',\)')ITI
          WRITE(52,'(I2,'' XRMN:'',\)')ITI
          DO I=0,op(21)
            AVARNEW=AVARNEW+XRMN(op(15)+I)
          ENDDO
          DIF=VARNEW-AVARNEW/(op(21)+1)  
          DO I=0,op(21) 
            XRMN(op(15)+I)=XRMN(op(15)+I)+DIF 
            WRITE(*,'(I3,''='',F9.4,'','',\)')op(15)+I,XRMN(op(15)+I)
            WRITE(52,'(I3,''='',F9.4,'','',\)')op(15)+I,XRMN(op(15)+I)
          ENDDO
          WRITE(*,'('' Av.='',F9.4)')VARNEW 
          WRITE(52,'('' Av.='',F9.4)')VARNEW 
        ELSE  
          XRMN(op(15))=VARNEW
        ENDIF
      ENDIF
	RETURN
 9    IF(op(15).LT.1.OR.op(15).GT.5)THEN !XRMX(5)
        Pause ' Option 15 out of range'
        ierr=8
      ELSE
        IF(op(21).GT.0)THEN
          WRITE(*,'(I2,'' XRMX:'',\)')ITI
          WRITE(52,'(I2,'' XRMX:'',\)')ITI
          DO I=0,op(21)
            AVARNEW=AVARNEW+XRMX(op(15)+I)
          ENDDO
          DIF=VARNEW-AVARNEW/(op(21)+1)  
          DO I=0,op(21) 
            XRMX(op(15)+I)=XRMX(op(15)+I)+DIF 
            WRITE(*,'(I3,''='',F9.4,'','',\)')op(15)+I,XRMX(op(15)+I)
            WRITE(52,'(I3,''='',F9.4,'','',\)')op(15)+I,XRMX(op(15)+I)
          ENDDO
          WRITE(*,'('' Av.='',F9.4)')VARNEW 
          WRITE(52,'('' Av.='',F9.4)')VARNEW 
        ELSE  
          XRMX(op(15))=VARNEW
        ENDIF
      ENDIF
	RETURN
10    IF(op(15).LT.1.OR.op(15).GT.40)THEN !pcmb
        Pause ' Option 15 out of range'
        ierr=8
      ELSE
        IF(op(21).GT.0)THEN
          WRITE(*,'(I2,'' PCMB:'',\)')ITI
          WRITE(52,'(I2,'' PCMB:'',\)')ITI
          DO I=0,op(21)
            AVARNEW=AVARNEW+pcmb(op(15)+I)
          ENDDO
          DIF=VARNEW-AVARNEW/(op(21)+1)  
          DO I=0,op(21) 
            pcmb(op(15)+I)=pcmb(op(15)+I)+DIF 
            WRITE(*,'(I3,''='',E9.4,'','',\)')op(15)+I,pcmb(op(15)+I)
            WRITE(52,'(I3,''='',E9.4,'','',\)')op(15)+I,pcmb(op(15)+I)
          ENDDO
          WRITE(*,'('' Av.='',E9.4)')VARNEW 
          WRITE(52,'('' Av.='',E9.4)')VARNEW 
        ELSE  
          pcmb(op(15))=VARNEW
        ENDIF
      ENDIF
	RETURN
11    IF(op(15).LT.1.OR.op(15).GT.40)THEN
        Pause ' Option 15 out of range'
        ierr=8
      ELSE
        IF(op(21).GT.0)THEN
          WRITE(*,'(I2,'' ZINI:'',\)')ITI
          WRITE(52,'(I2,'' ZINI:'',\)')ITI
          DO I=0,op(21)
            AVARNEW=AVARNEW+ZINI(op(15)+I)
          ENDDO
          DIF=VARNEW-AVARNEW/(op(21)+1)  
          DO I=0,op(21) 
            ZINI(op(15)+I)=ZINI(op(15)+I)+DIF 
            WRITE(*,'(I3,''='',F9.4,'','',\)')op(15)+I,ZINI(op(15)+I)
            WRITE(52,'(I3,''='',F9.4,'','',\)')op(15)+I,ZINI(op(15)+I)
          ENDDO
          WRITE(*,'('' Av.='',F9.4)')VARNEW 
          WRITE(52,'('' Av.='',F9.4)')VARNEW 
        ELSE  
          ZINI(op(15))=VARNEW
        ENDIF
      ENDIF
	RETURN
      END
