c     4/29/2000
c                               Program TRG  - v.7.0 with iteration
c-----------------------------------------------------------------------
c                    11-13-96   Modified by HCF and by AVS  
c                    1-29-97    Modified by HCF
c                    9-3-97     Documented for FORTRAN 90 graphics by HCF
c            Model of Tree Ring Growth   (season growth)
c-----------------------------------------------------------------------
c  Program needs subroutins:
c
c     file of options:            trg70.INF
c     file of parameters:         trg70.PAR
c     file of initial conditions: trg70.i0 (not .iO)
c     file with constants:        MCconst.CST
c     cambial parameters          camb70.PAR
c     subroutines:                camb70 .for
c                                 camb70s.for
c                                 iterate2.for
c                                 redrmt.for
c                                 stat2000.for
c                                 trs12000.for
c                                 trs22000.for
c ---------------------------------------------------------------------
      INCLUDE 'fgraph.fi'
      INCLUDE 'fgraph.fd'
      INTEGER*2             itext
      REAL TFUNC
	REAL, DIMENSION(366)::Temp,Rad,Dlen,Prec,DewPt,d18Oprec,d18Ovap,
     +                      trp,transp,sm,Resist,Resistwb,stemw,Phot,Ci,
     +                      Su1,Su2,Su3,Gleaf,xleaf,waterloss,
     +                      MaxWatLoss,WatProp,GRcamb,GRenla,GRmat,Groot
     +                      ,Resp,Dist,dDprec,dDvap,
     +					  Env_l,Env_c,Env_e,Env_m,Env_r                
	REAL, DIMENSION(366)::d13Cps,d13CstL,d13CstS,d13CstR,d13CL,d13CS,
     +                      d13CR,d13CC,
     +					  dDLw,dDps,dDstL,dDstS,dDstR,dDCL,dDCS,dDCR,
     +					  dDXw,dDC,
     +					  d18OLw,d18Ops,d18OstL,d18OstS,d18OstR,
     +					  d18OCL,d18OCS,d18OCR,d18OXw,d18OC
      REAL, DIMENSION(366)::Ctrcmb,Ctmcmb,Contr,Contr2,Wab,Wab1,e,es,
     +				      dendgr,dgrmin,dgrmax,balance
      REAL Correct(3,100),DCorrect(3,100)
      REAL      mswidth,mswall
      REAL      lat, Mleaf, Mstem ,Mroot,MFroot,f
	REAL	  hold(20),Larea,Lthick
	REAL	  Ca(111),d13Ca(111)
	CHARACTER yr*4(111),co2data*12,fname4*70
      INTEGER   op(40),alt,dlstop

      INTEGER   begyear, endyear ,snn, sunww, countd, age, agemax,daybeg
      CHARACTER clfile*8, path*40,   fname*70,  fname2*70,  fname3*70,
     +          csfile*8, pathcs*40, sph*1,fx*40, fc*12,fd*12,
     +          filt*1, txterr*60 ,AA*10 ,idcrn*6,fyy*8,
     +          fyz*8

      CHARACTER*1 text*30,txt*3(100)
	REAL, DIMENSION(366):: nr,nc,ne,nm,DifDen,WallAr
	REAL ch(12,1000),Gr(12),count,Falseday,FalseLw,Lw,Ew,WallArea
	REAL LwWallAr,Pre2WallAr,Pre1WallAr,d13CLatew,d13CPre2,d13CPre1
	REAL dDLatew,dDPre2,dDPre1,d18OLatew,d18OPre2,d18OPre1
	REAL, DIMENSION(366)::LATEDD,LATED13C,LATED18O,PRE2D13C
	REAL,  DIMENSION(366):: PRE2DD,Pre2d18O,Pre1d13C,Pre1dD,Pre1d18O
	INTEGER kcmb(10),num(4)
      CHARACTER      state*1(1000)

      COMMON/CHRN/chr(100),chrest(100),ICHRMS(100)
      COMMON/A/wall(1000),sizz(1000),wallrev(1000),sizerev(1000)
     +,calcN(100),realN(100),estn(100),estw(100),realnos(100),
     +realw(100),icln,rep,mswidth,mswall,nreal,MISSRING(100)
      COMMON/SUMS/
     +nnring,   !3*Number of ring pairs without one of them missing
     +summsr,   !1*Sum sq replicate measurs of ring width(crn files)
     +summsw,   !2*Sum sq replicate measurs wall thick(crn filis)
     +snn,      !23*Sum normalized measured cells ave over replicates
     +sumn,     !4*Sum measured cell replicates for cell width analysis
     +sumnw,    !5*Number of rings used for wall thickness analysis
     +sunww,    !36*Sum measured walls which have replicate measurements
     +sunnw,    !6*Number of replicates with wall thickness measurements
     +sumrepw,  !7*Sum of replications of wall thickness measurements
     +sumrep,   !9*Sum of number of all replications
     +sumest,   !13*Sum normalized cell size estimates
     +sumwest,  !26*Sum estimated wall thicknesses (if actual reps)
     +sumsqest, !16*Sum squares normalized cell size estimates
     +sumsqwest,!29*Sum sq. estimated wall thick. (if act reps exist)
     +sumszrel, !14*Sum size of actual wall measurements
     +sumreal,  !8*Sum of ring width measurements
     +sqreal,   !17*Sum sq. averaged measured cell widths
     +sqwreal,  !30*Sum sq. ave real wall measurements (if replicated)
     +sumwreal, !27*Sum real wall measures (if actual replicates exist)
     +sumdsz,   !15*Sum estimated-actual differences cell sizes (resid)
     +sumdwa,   !28*Sum residuals of wall thickness
     +sqdsz,    !18*Sum squares of residuals for cell sizes
     +sqdwa,    !31*Sum squares residuals for wall thickness
     +rszmax,   !22*Absolute velue max of cell size residuals
     +rwamax,   !35*Absolute value max of wall thickness residuals
     +xy,       !19*Sum cross products of measur and est cell sizes
     +xywall,   !32*Sum cross products of measured and est wall thick
     +termax,   !20*Maximum estimated cell size
     +tewmax,   !33*Maximum estimated wall thickness
     +tarmax,   !21*Maximum measured average (over cell size rep) 
     +tawmax   !34*Maximum measured average (over wall thick replicates)
      COMMON/PARMS/  p(60), b(100), zini(40), den(5), piso(40),
     + rmc(3),rmt(3),grc(5),gc(5),prp(3),upt(5),xrmn(5),xrmx(5)
      COMMON/COITER/AITI(3),VAR(3),PIT(10),VAROLD(10),AITIOLD(10),
     +isave(5),BEGVAR

	text= ' Press Enter Key to Continue'
      txterr=' End of calculation'
      itext=1
c     CALL TEXTSET(itext)
	jjj=0                           !Year Counter
	countd=0
      IIGO=0   !Counter for GOTO statement
      WRITE(*,'(1x,A70)')
     +' Ŀ ',
     +'      Program TreeRing - v. 2000 w Isotope Fract.     ',
     +'         19/04/96       by Alexander Shashkin         ',
     +'         29/10/99       by Harold Fritts              ',
     +'         29/10/99       by Deborah Hemming            ',
     +'         19/04/96       by Geoffry Downes             ',
     +'      Model of Tree-Ring Structure and Daily Growth   ',
     +'                 W E L C O M E !                      ',
     +'  '
C  **************************************************************   
C  Read Parameters in .INF file
C  **************************************************************    
c ------------read file 'trg2000.inf' --------------
      OPEN(13,STATUS='OLD',FILE='trg70.INF',ERR=10)
      READ(13,*)
      READ(13,'(A1/A40/A8)')filt,path,clfile
	READ(13,'(A12/A40/A8/A11)')fc,PathCS,csfile,CO2data !fc index
      READ(13,*)
      READ(13,'(I4)')(op(i),i=1,40)
	READ(13,*)
      READ(13,'(F12.6)')(pit(i),i=1,10)  !Options for Iteration Program
      CLOSE(13)
C  ********************************************************************     
C    Option 9 is 0 when file and file path statement are to be read in
C  ********************************************************************     
      IF(op(9).eq.0)THEN
        WRITE(*,'('' Input information on File with climatic data''/
     +          '' Drive:\path\     : '',A40)')path
        WRITE(*,'('' New Drive:\path\ : '',\)')
        READ(*,'(A40)')fx
        IF(fx.NE.' ')path=fx
        WRITE(*,'('' File name    : '',A8)')clfile
        WRITE(*,'('' New File name: '',\)')
        READ(*,'(A8)')fyy
        IF(fyy.NE.' ')clfile=fyy
      ENDIF
      idcli=INDEX(path,' ')-1   !Position of last valid line of path 
   
      READ(clfile(5:8),'(I4)')begyear !Read beginning yr 
C  *******************************************************************        
C    Option 9 is 0 when file and file path statement are to be read in
C  *******************************************************************  
      ringwidth=0.0
      ig=begyear
      endyear=op(28)
C  *************************************************************************     
C    Opt  1 is 0 when no measurements are read in for validation purpose
C         1 when only cell size and wall thickness measurements are read
C         3 when index data are used with size and wall thickness meas
C    No option is provided yet for index data without size and thickness 
C  *************************************************************************     
       IF(op(1).GT.1) THEN
C  *************************************************************************     
C    Option 9 is 0 when file and file path statement are to be read in
C  *************************************************************************     
       IF(op(9).eq.0)THEN
         WRITE(*,'('' Input information on File with cell size and index
     + data:''/'' Drive:\path\: '',A40)')pathcs
         WRITE(*,'('' New Drive:\path\ : '',\)')
         READ(*,'(A40)')fx
         IF(fx.NE.' ')pathcs=fx
         WRITE(*,'('' File name for cell size data : '',A12)')csfile
         WRITE(*,'('' New File name: '',\)')
         READ(*,'(A8)')fyz
         IF(fyz.NE.' ')csfile=fyz
         WRITE(*,'('' File name for indexed data : '',A12)')fc
         WRITE(*,'('' New File name: '',\)')
         READ(*,'(A8)')fd
         IF(fd.NE.' ')fc=fd
         WRITE(*,'('' File name for co2 data : '',A12)')co2data
         WRITE(*,'('' New File name: '',\)')
         READ(*,'(A8)')fd
         IF(fd.NE.' ')co2data=fd
       ENDIF
C  *************************************************************************     
C    Option 1 is 1 or 2 when file and file path statement are needed 
C  *************************************************************************     
       idcs=LEN_TRIM(pathcs)  !Position of last valid line of path 
       idcsf=LEN_TRIM(csfile) !Position of last valid line of file name
       idco2=LEN_TRIM(co2data)!Position of last valid line of co2 file 
       IF(idcsf.LE.0)idcsf=8
C  *************************************************************************     
C    If no file name, use path and file names from INF file
C  *************************************************************************     
         fname2=PathCS(1:idcs)//csfile(1:idcsf)//'.CRN' 
         fname3=PathCS(1:idcs)//fc
	   fname4=PathCS(1:idcs)//co2data(1:idco2)
      END IF
C  *************************************************************************     
C    Sets parmeters for Iteration Program
C  *************************************************************************     
      ITI=0
      ISTAT=3
C  *************************************************************************     
C    Opens and reads Chronology Data if Option 1 GE 3
C  *************************************************************************     
      IF(op(1).GE.3)THEN
        OPEN(12,FILE=fname3,STATUS='OLD',ERR=6) !Open Indexed Chronology
        CALL TRRW(idcrn,nchyr,chr,begyear,12,endyear-begyear+1,op)
      IF(op(13).eq.0)CLOSE(55)
        CLOSE(12)
      ENDIF
C  *************************************************************************     
C    Starts iteration procedure if 0p 13 is 1
C  *************************************************************************     
      IF(op(13).EQ.1)THEN
         IF(op(1).EQ.1)THEN
           PAUSE ' Option 1 = 1. No Independent Data.  Can not run itere
     +ation.'
           GOTO 27
         ENDIF
C  *************************************************************************     
C    Creates Iteration Output file
C  *************************************************************************     
         OPEN(52,FILE='ITERATE.OUT',STATUS='UNKNOWN',ERR=91)
         WRITE(52,'('' FILE ITERATE.OUT '',I4,'' - '',I4)')begyear,
     +    endyear
       ENDIF
C  **********************************************    
C    Read PARAMETERS 
C  **********************************************    
! Cambium parameters    
      CALL CMBPAR(b,kcmb)
! Main parameters from file TRG*.par      
	OPEN(11,STATUS='OLD',FILE='Trg70.par',ERR=13)
      READ(11,'(F12.6)')(p(i),i=1,60)
      READ(11,*)
      READ(11,'(F12.6)')(den(i),i=1,5)
      READ(11,*)
      READ(11,'(F12.6)')(rmc(i),i=1,3)
      READ(11,'(F12.6)')(rmt(i),i=1,3)
      READ(11,*)
      READ(11,'(F12.6)')(grc(i),i=1,5)
      READ(11,*)
      READ(11,'(F12.6)')(gc(i),i=1,5)
      READ(11,*)
      READ(11,'(F12.6)')(prp(i),i=1,3)
      READ(11,*)
      READ(11,'(F12.6)')(upt(i),i=1,5)
      READ(11,*)
      READ(11,'(F12.6)')(xrmn(i),i=1,5)
      READ(11,*)
      READ(11,'(F12.6)')(xrmx(i),i=1,5)
      CLOSE(11)
! Parameters for calculation stable isotops
      OPEN(11,STATUS='OLD',FILE='piso.par',ERR=9999)
      READ(11,*)
      READ(11,'(F12.6)')(piso(i),i=1,40) 
      CLOSE(11)
! Correction parameters
      p(5)=p(5)*100   !  scales max resistance for water
C  **********************************************
C    Initial data of tree form
C  **********************************************
      OPEN(17,STATUS='OLD',FILE='trg70.i0',ERR=113)
      READ(17,'(F12.4)')(zini(i),i=1,40)
      CLOSE(17)
      IF(op(13).EQ.1)THEN
C  *************************************************************************     
C    Identifies and displays data used in Iteration 
C  *************************************************************************     
         CALL ITISETUP(NITI,MO,ITI,KCMB,OP,isave)
C  *************************************************************************     
C    If Iteration is in process it gets values from paramters for iteration
C  *************************************************************************     
         CALL GETVAR(VARNEW,op,ierr)
         VAR(ITI)=VARNEW
         IF(ierr.NE.0)GOTO 95
	END IF
      OPEN(59,FILE='DATETIME.DAT')
      CALL DATETIME(59)
	WRITE(59,'(''  '')')
	CLOSE(59)
      icount=1
	dorm=500.
C  *************************************************************************     
C    RETURN TO 400 FOR continuing ITERATION - Begins here
C  *************************************************************************     
400   CONTINUE
C  *************************************************************************     
C    Opens Measurement File just before it needs it
C  *************************************************************************     
      IF(op(1).GT.1.AND.op(29).GE.begyear.AND.op(29).LE.endyear)THEN
        OPEN(40,FILE=fname2,STATUS='OLD',ERR=999) !Open indep meas.CRN 
        READ(40,'(A)')AA 
      ENDIF 
CC---------------------------------------------------------------------
      jyear=begyear 
      tranmax=0.0
      JJ=1            !Year counter set to first year
      Pmax=p(56)      !Upper limit of photosynthetic rate 
	coef=35090.0    ! mMCO2/kg dry weigth 
!---------------------------------------------------------------------
! Initial data at time of beginning of calculation
! Inital data for cambium
      CALL cmbini(b,ch,state,num)
	nr(1)=num(1)
	nc(1)=num(2)
	DO i=1,num(1)
	   Correct(1,i)=0  
	   Correct(2,i)=num(1)-i+1 !Number in ring corrected
	   Correct(3,i)=zini(11) !Initial d13CstS (in stem)
	ENDDO
! Initial value for mixing of xylem and leaf water in the leaf...see isotope LW routine
c	f=1.0
! Initial soil moisture 
      sm(1) =zini(14)
! Initial dD and D18O of precipitation and photosynthate
	dDXw(1)=-60
	d18OXw(1)=-4.0
	dDps(1)=-60.0
	d18Ops(1)=15.0
! Initial starch or sucrose	     
      Su1(1)=zini(15)     !  in leaves
      Su2(1)=zini(16)     !  in stem
      Su3(1)=zini(17)     !  in roots
! d13C in stored sucrose
	d13CstL=zini(10) !  in leaves
	d13CstS=zini(11) !  in stem
    	d13CstR=zini(12) !  in roots
! dD in stored sucrose
	dDstL=zini(4) !  in leaves
	dDstS=zini(5) !  in stem
    	dDstR=zini(6) !  in roots
! d18O in stored sucrose
	d18OstL=zini(7) !  in leaves
	d18OstS=zini(8) !  in stem
    	d18OstR=zini(9) !  in roots
! Initial d13C in cellulose of 
	d13CL=zini(10)
	ch(10,1)=zini(11)
	d13CR=zini(12)
! Initial dD in cellulose of 
	dDCL=zini(4)
	ch(11,1)=zini(5)
	dDCR=zini(6)
! Initial d18O in cellulose of 
	d18OCL=zini(7)
	ch(12,1)=zini(8)
	d18OCR=zini(9)
! Water balance initial data
      IF(zini(1).LE.0.0)THEN
	  stemw(1)=1.0-den(3)/den(1) !kg/m**2
      ELSE
	  stemw(1)=zini(1)
      ENDIF
        
!--------------------------------------------------------------------
! Open file to write annual output data
      IF(op(12).EQ.2.AND.op(13).EQ.0)THEN
        OPEN(53,FILE=clfile(1:4)//'totl.dat')
        WRITE(53,'(I2,38I12)')(I, I=1,39)
c	  WRITE(53,'(I2)') I
        WRITE(53,'(A6,38A12)')'year','Phot','Res','Gleaf','Gcamb',
     +    'Genla','Gmat','Groot','SuL','SuS','SuR',
     +    'd13CL','d13CS','d13CR','dDCL','dDCS','dDCR','d18OCL',
     +    'd18OCS','d18OCR','nr','ringwidth','Mleaf','Mstem',
     +    'Volume','Mroot','Gr Begins','FalseLw','Lw','Ew',
     +    'Pre1d13C','Pre2d13C','Lated13C','Pre1dD','Pre2dD','LatedD',
     +    'Pre1d18O','Pre2d18O','Lated18O'
      END IF
C  *******************************************************************    
CC                   THE ANNUAL CYCLE BEGINS HERE
C  *******************************************************************    
! New initial foliage, sapwood and fine root masses
 20   IF(op(12).EQ.2.AND.op(13).EQ.0)THEN
 	  OPEN(17,FILE=clfile(1:4)//clfile(7:8)//'I.DAT')
	  WRITE(17,'('' TRGINPUT DATA AND OUTPUT.'',/)')
      ENDIF
      IF(icount.LT.op(2))THEN
          IF(op(13).EQ.0)WRITE(*,'(''   Year = '',I4)')ig
	  icount=icount+1
	ELSE
        IF(op(13).EQ.0)WRITE(*,'(''   Year = '',I4)')ig
          icount=1
        IF(op(13).EQ.0)CALL clearscreen($gclearscreen)
	END IF
      CALL TRGINPUT(p,prp,zini,b,den,op,begyear,ig,
     *   endyear,jj,ringwidth,hold,age,agemax,depth,sarea) 
      Mleaf=0.0
      DO i=1,p(1)
	  Mleaf=hold(i+1)+Mleaf ! New mass of leaves at end of year 
      ENDDO    
	Larea=Mleaf*p(3)      
      Mstem=hold(4)  ! Living Mass of stem
      Mroot=hold(5)  ! Living Mass of all roots from Input
	MFroot=hold(7) ! Living Mass of fine roots from input
	MFroot=mroot
	ASC=0.6 
	form=hold(9)
	volume=hold(10)	  
! from that label annual cycle begins at constant form of the tree
 21   fname=PATH(1:idcli)//clfile//'.cli' ! Makes new climate file name
      CALL MCLIMAT(Temp,Prec,DewPt,dDprec,d18Oprec,dDvap,d18Ovap,
     +             trp,Rad,Dlen,sph,fname,lat,alt,M1,M2,p(4),op,e,es)
      nu=M1-1          !nu records beginning of climatic data
      m=M2-M1+1        !m -records length of available climatic data
C  *************************************************************************     
CC  If filter asked for, climatic data filtered (Not recommended in new model)                
C  *************************************************************************     
      IF(filt.EQ.'A'.OR.filt.EQ.'L'.OR.filt.EQ.'V')
     +              Call FILTER(temp,m,filt)
C  *************************************************************************
C      IF(op(12).EQ.2)THEN  ! If all files to be written, opens them
      IF(op(12).EQ.2.AND.op(13).EQ.0)THEN
        jas=0              ! Parameter for writing file
        open(51,FILE=clfile(1:4)//clfile(7:8)//'L.DAT')
        WRITE(51,'(i2,18i12)')(i, i=1,19)
	  WRITE(51,'(A5,18A12)')' Day ',
     +                    ' LfCarbon ',' LfWater ',' LfTemp ',
     +                    ' CmCarbon ',' CmWater ',' CmTemp ',
     +                    ' EnCarbon ',' EnWater ',' EnTemp ',
     +                    ' MtCarbon ',' MtWater ',' MtTemp ',
     +                    ' RtCarbon ',' RtWater ',' RtTemp ',
     +                    '  CrownCtl ',' CrownCtmat '
      ENDIF
     
C  ********************************************************************   
c                         Photosynthetic MODEL           
C  ********************************************************************
! ---------------------------------------------------------------------
! The initial data for each year
! ---------------------------------------------------------------------   
      dlstop=0
CC photosynthesis
! The data on concentration CO2 and d13C in air for current year
	OPEN(32,STATUS='OLD',FILE=fname4)
	READ(32,'(A4,F8.2,F8.2)')(yr(j),Ca(j),d13Ca(j),j=1,101)
      CLOSE(32)
	k=1
 41	IF(clfile(5:8).NE.yr(k))THEN
	  k=k+1
	  GOTO 41
	ENDIF
	airCO2=Ca(k)/24.0
	aird13C=d13Ca(k)
! no available sugar in the tree at begining of season
	FinalPs=0.0
      Ci    = p(27)
      resist = p(4)
! Initial value for mixing of xylem and leaf water in the leaf...see isotope LW routine
	f=1.0
CC foliage
! xleaf(1) is mass of growing tissue in leaf at beginning of season
      xleaf(1)  = prp(1)*Mleaf/p(1) 
      Gleaf  = 0.0
	GConst    = 0.0
	Gleafx    = 0.0
! cambium growth
	GRcamb(i)=0.0
	GRenla(i)=0.0
	GRmat(i)= 0.0
! control functions
      Contr  = 0.0
      Ctrcmb=  0.0
	Env_l=0.0
	Env_c=0.0
	Env_e=0.0
	Env_m=0.0
	Env_r=0.0
      go   =1.0
! Isotopes
	d13CL=zini(10)
      
! begining of season of growth
      ibeg=366      ! Beginning of growth set to end of year 
      daybeg=p(33)  !To Control beginning of growth by daylength
      IF(op(12).EQ.5.AND.op(13).EQ.0)THEN
	  OPEN(42,FILE=clfile(1:4)//clfile(7:8)//'#.DAT')
	    DO i=1,100
	      WRITE(txt(i),'(I3)')i
	    ENDDO
	  WRITE(42,'(A4,300A7)')' t  ',(' to ',' j ',txt(i),i=1,100)
	END IF       
      IF(op(12).EQ.2.AND.op(13).EQ.0)THEN
	  OPEN(45,FILE=clfile(1:4)//clfile(7:8)//'CG.DAT')
	  WRITE(45,'('' Cambial data '')')
	END IF       
C ***********************************************************************
C ***********************************************************************
CC   INTERYEAR CYCLE  DAILY CYCLE BEGINS
C ***********************************************************************
C ***********************************************************************
      DO i=1,m
	  saveSu1=Su1(i)   
	  saveSu2=Su2(i)   
	  saveSu3=Su3(i)
	  bal=Su1(i)+Su2(i)+Su3(i)+FinalPs
	  
	  saved13CstL=d13CstL(i)
	  saved13CstS=d13CstS(i)
	  saved13CstR=d13CstR(i)   

	  savedDstL=dDstL(i)
	  savedDstS=dDstS(i)
	  savedDstR=dDstR(i)   

	  saved18OstL=d18OstL(i)
	  saved18OstS=d18OstS(i)
	  saved18OstR=d18OstR(i)  
! m is length of available climatic data from file or 364 
	  dist(i)=0.0          
! Calculates transpiration
        CALL tran(p,Dlen(i),trp(i),sm(i),Mleaf,MFroot,ResWb,sowab,stwab,
     +            depth,sarea,hold(8),stemw(i))
        Resistwb(i)=ResWb
! Calculation photosynthesis 
        CALL phsyn(p,Temp(i),Rad(i),Dlen(i),Phot(i),
     +              Mleaf,Pmax,ResWb,CO2i,airCO2,R)
	  Ps=Phot(i)+FinalPs
! Ps is used as a current avilable photosynthate 
        Ci(i)=CO2i
        resist(i)=R
        Transp(i)=Trp(i)*p(4)/R
	  MaxWatLoss(i)=Trp(i)*Dlen(i)*Larea !max poss water loss per day
	  waterloss(i)=Transp(i)*Dlen(i)*Larea !water lost per day
	  WatProp(i)=waterloss(i)/MaxWatLoss(i)
	 
c	  f=MAX(0.85,WatProp(i))
	  f=MAX(0.3,((0.7*WatProp(i))+0.3)) !proxy for residence time of water in leaf

! Correction transpiration on resistence after phosynthesis 
	  CALL Ciso (alt,aird13C,airCO2,Ci(i),d13Cps(i)) 
        CALL water(p,sm,Prec(i),sowab,stwab,Transp(i),i,depth,sarea,
     +                 hold(8),stemw,Dlen(i),dgrmin(i),dgrmax(i))
c        nisowab is water absorbed in night, hold(8) is sapwood volume
c
        Wab(i)=sowab
        Wab1(i)=stwab
	  CALL HOisoLw(f,prec(i),temp(i),sarea,depth,sm(i),p,e(i),es(i),
     +			dDprec(i),d18Oprec(i),dDvap(i),d18Ovap(i),dDXw(i),
     +		    d18OXw(i),dDXw(i+1),d18OXw(i+1),dDLw(i),d18OLw(i))
c     Check when Growth begins starting when daylen ok.  Then sum temperature
c     over interval p(31).  Then start growth on day when the sum of t
c     over this interval equals or exceeds the critical value. ibeg
C     
        IF(Dlen(i).GT.p(50).AND.ibeg.EQ.366)THEN 
	    IF(Daybeg.LT.0.0)THEN
! Calculates temp and resistance backwards
	      CALL beggr(temp,resist,p,i,ibeg) 
! ibeg is Julian Day growth begins
          ELSE
	      daybeg=daybeg-1 ! When daybeg LT 0, Growth may begin next day
!          but it depends upon temp sum and resistance after daybeg is 0
          END IF 
	  END IF ! Control of Growth beginning by Day Length

CC  Maintenance respiration of leaf, stem and root
        Rleaf=(Su1(i)+Ps)/(Su1(i)+Ps+p(34)*Mleaf/1000.0)*rmc(1)*
     +       Mleaf * exp(rmt(1)*(temp(i)-10.0))
c	  Larea=Mleaf*p(3)
	  Lthick=Mleaf/Larea ! Assuming Mleaf=volume of leaf, density=1
	  CALL HOps(dDLw(i),d18OLw(i),dDXw(i),d18OXw(i),dDps(i),d18Ops(i))
	  CALL IsoResp('leaf',airCO2,Rleaf,Lthick,d13Cps(i))
	  CALL Alloc('leaf',0.0,Rleaf,Ps,Su1(i),Su2(i),Su3(i),
     +	  Mleaf/1000.0,volume,Mroot/1000.0,
     +	  d13Cps(i),d13CstL(i),d13CstS(i),d13CstR(i),0.0,x,d13CC(i+1),
     +	  dDps(i),dDstL(i),dDstS(i),dDstR(i),1.0,x,dDC(i+1),
     +	  d18Ops(i),d18OstL(i),d18OstS(i),d18OstR(i),0.0,x,d18OC(i+1))
C
        Rstem=(Su2(i)+Ps)/(Su2(i)+Ps+p(34)*volume)*rmc(2)*volume*
     +										exp(rmt(2)*(temp(i)-10.0))
c	  
	  CALL IsoResp('stem',airCO2,Rstem,volume,d13Cps(i))
	  CALL Alloc('stem',0.0,Rstem,Ps,Su1(i),Su2(i),Su3(i),
     +	  Mleaf/1000.0,volume,Mroot/1000.0,
     +	  d13Cps(i),d13CstL(i),d13CstS(i),d13CstR(i),0.0,x,d13CC(i+1),
     +	  dDps(i),dDstL(i),dDstS(i),dDstR(i),1.0,x,dDC(i+1),
     +	  d18Ops(i),d18OstL(i),d18OstS(i),d18OstR(i),0.0,x,d18OC(i+1))
C
        Rroot=(Su3(i)+Ps)/(Su3(i)+Ps+p(34)*Mroot/1000.0)*rmc(3) *
     +       Mroot * exp(rmt(3)*(temp(i)-15.0))
C
	  CALL IsoResp('root',airCO2,Rroot,Mroot,d13Cps(i))
	  CALL Alloc('root',0.0,Rroot,Ps,Su1(i),Su2(i),Su3(i),
     +	  Mleaf/1000.0,volume,Mroot/1000.0,
     +	  d13Cps(i),d13CstL(i),d13CstS(i),d13CstR(i),0.0,x,d13CC(i+1),
     +	  dDps(i),dDstL(i),dDstS(i),dDstR(i),1.0,x,dDC(i+1),
     +	  d18Ops(i),d18OstL(i),d18OstS(i),d18OstR(i),0.0,x,d18OC(i+1))
! Total respiration of tree mMCO2/day
        Resp(i)=Rleaf+Rstem+Rroot ! Total respiration in tree

C  ************************************************************************
CC  BEGINNING OF CAMBIUM CONTROL CALCULATIONS
C  ************************************************************************
CC  Limiting conditions: limiting for temperature
C ---------------------------------------------------------------------
CC THE GROWTH ASSIMILATION: This If includes period when growth occurs
C ---------------------------------------------------------------------
         IF(i.GE.ibeg)THEN ! GROWTH BEGINS 
           IF(op(12).EQ.2.AND.op(13).EQ.0.AND.i.EQ.ibeg)THEN
             OPEN(14,FILE=clfile(1:4)//clfile(7:8)//'C.DAT')
             WRITE(14,'(A28,I4)')' Growth begins day:',i
           END IF
c	f=f-(0.50/(365-ibeg)) ! % exchange between evaporated leaf water 
! Foliage growth
! upt(1)=max leaf growth rate 
! xleaf is current mass of foliage
! Ast - Growth assimilation due to T
           AsT=TFUNC(Temp(i),p(35),p(36),p(37),p(38))
! Limiting conditions: limiting for water stress
	     Rg=R ! Rg=Resistance
	     IF(R.GT.ResWb)Rg=p(4) ! Resistance Rg set to Min if R GT ResWb
	     AsWl=MIN(1.0,(xrmx(1)-Rg)/(xrmx(1)-xrmn(1))) 
           IF(AsWl.LT.0)Aswl=0.0
! Limiting foliage growth by available sucrose concentration
		 available_sugar=MAX(0.0,Su1(i)+Ps)
           Call CLIMIT(gc(1),Mleaf,gc(2),available_sugar,Asc)
c           Asc=(available_sugar-gc(2)*Mleaf)/(available_sugar+(gc(1)
c     +        -gc(2))*Mleaf)
c           IF(Asc.LT.0)Asc=0.
!
 		 xm=upt(1)*MAX(0.0,(1-(xleaf(i)+GConst)/Mleaf*p(1))) ! eq 16a
           Fleaf=Asc*AsWl*AsT
           Env_l(i)=Fleaf
		 Gleaf(i)=coef/grc(1)*xm*Fleaf*prp(1)*Mleaf/p(1)     ! mMCO2/day
c When leaf growth stops,Gleaf(i) temporarely estimated
           IF(Gleaf(i).EQ.0.0)Gleafx=Gleafx+xm*prp(1)*Mleaf/p(1)
c Control is Growth rate (Eq 16a new ms)/maximum growth rate of leaves
!
		 Contr(i)=xm*Fleaf/upt(1)
! 
		 IF(op(6).EQ.1.0)Contr2(i)=Contr(i) !Used to restart leaf growth
! The following stops growth if diminished to critical level            
! go is used to check foliage growth. 
! if go=0 it mean that foliage stop grow irreversably   
           IF(go.EQ.1.AND.i.GT.ibeg+p(57))THEN 
! duration of foliage growth GE p(57)
! p(7):period for averaging growth, p(8) average rate to stop growth
! Here it is checking and using go to further calculations               
              CALL critical(Contr,1.0,i,ibeg,p(7),p(8),go,avG) 
           ELSEIF(go.EQ.0.AND.i.GT.ibeg+p(57).AND.op(6).EQ.1)THEN
			CALL critical(Contr2,1.0,i,ibeg,p(7),p(8),go,avG)
	        IF(go.EQ.1)GConst=Gleafx
           END IF
           Gleaf(i)=Gleaf(i)*go  
		 Contr(i)=Contr(i)*go  
!
	  CALL Alloc('leaf',xleaf(i)*coef,Gleaf(i),Ps,Su1(i),Su2(i),Su3(i)
     +,Mleaf/1000.0,volume,Mroot/1000.0,d13Cps(i),d13CstL(i),d13CstS(i),
     +d13CstR(i),d13CL(i),d13CL(i+1),d13CC(i+1),dDps(i),dDstL(i),
     +dDstS(i),dDstR(i),dDCL(i),dDCL(i+1),dDC(i+1),d18Ops(i),d18OstL(i),
     +d18OstS(i),d18OstR(i),d18OCL(i),d18OCL(i+1),d18OC(i+1))

! Foliage mass in kg 
		 xleaf(i+1)=xleaf(i)+Gleaf(i)*grc(1)/coef 
! Foliage area in m2, where 1kg=7m2 from needle measurements.
C ---------------------------------------------------------------------    
cc  Crown control of xylem growth and maturation (Ct)
C   It is used same value  contr() 
C ---------------------------------------------------------------------     
           CALL critical(contr,1.0,i,ibeg,b(30),-1.0,goct,  x)
! output of curoutine x is the moving avarage of contr()            
! Ct is used to control formation of  latewood
           Ct=MIN(1.0,x/p(28))
           CALL critical(contr,1.0,i,ibeg,b(70),-1.0,goct,  x) 
! output of curoutine x is the moving avarage of contr()            
! Ctm is used to control maturation of latewood (difference by period)
           Ctm=MIN(1.0,x/p(29))
	     Ctm=1-Ctm !Hal did this so Ctm goes from 0 to 1
	     Ctmcmb(i)=Ctm
           Ctrcmb(i)=Ct
!!!!!!!!!!!!  Ct now is changed to control by cambium
!           CALL critical(Ccamb,1.0,i,ibeg,b(30),-1.0,gocmb,Cgc)
!           CALL critical(Cenla,1.0,i,ibeg,b(50),-1.0,goenl,Cge)
!           CALL critical(Cmat ,1.0,i,ibeg,b(70),-1.0,gomat,Cgm)
C ---------------------------------------------------------------------
	    CALL camb70(op,ch,b,num,state,temp(i),Rg,Ps,Su1(i),Su2(i),
     +     Su3(i),d13Cps(i),d13CstL(i),d13CstS(i),d13CstR(i),    
     +	 d13CC(i+1),dDps(i),dDstL(i),dDstS(i),dDstR(i),dDC(i+1),
     +	 d18Ops(i),d18OstL(i),d18OstS(i),d18OstR(i),d18OC(i+1),
     +	 i+nu,dlen(i),Mleaf,volume,hold(8),Mroot,form,Ct,Cte,
     +     Ctm,Gr,Correct,dorm,distxx,b3)    
           nr(i+1)=num(1) 
           nc(i+1)=num(2)
           ne(i+1)=num(3)
           nm(i+1)=num(4)
	     GRcamb(i)=Gr(1)
	     GRenla(i)=Gr(2)
	     GRmat(i)= Gr(3)
	     Env_c(i)=Ct
	     Env_e(i)=Cte
	     Env_m(i)=Ctm
C ---------------------------------------------------------------------
! dendrograph
	     trwi=0.0
		 DO l1=1,num(1)
		    trwi=trwi+ch(8,l1) 
		 ENDDO
		 dendgr(i)=trwi 
  	     CLOSE(42)

c *********************************************************************
c       ELSE  Continue with period before growth began
c *********************************************************************
         ELSE 
! dendrograph dynamic

         dendgr(i+1)=dendgr(i)
         nr(i+1)   = nr(i)
         nc(i+1)   = nc(i)
         ne(i+1)   = ne(i)
         nm(i+1)   = nm(i)
! foliage dynamic
         xleaf(i+1)=xleaf(i)
! control functions
	   ENDIF
! ---------------------------------------------------------------------
! next calculations independent on growth period
! ---------------------------------------------------------------------
C Root growth
! limiting by water supply
	   AsWr=MIN(1.0,(xrmx(2)-Rg)/(xrmx(2)-xrmn(2))) 
         IF(AsWr.LT.0)Aswr=0.0
! limiting by sugar supply
c         fmc=gc(5)*Mroot !M M Const converted to toatal sugar
c	   fmcmin=p(45)*Mroot ! Scaled proportion of root mass
c	   IF(fmc.LE.2*fmcmin)fmcmin=0.499*fmc 
! If total MM sugar LE 2 x root mass, Scaled root mass = .499 total sugar
         available_sugar=Su3(i)+Ps
c         AscR=(available_sugar-fmcmin)/
c    +        (available_sugar+fmc+2*fmcmin)
c         CALL CLIMIT(gc(5),Mroot,gc(4)*p(45),Su3(i)+Ps,fRlim)
         CALL CLIMIT(gc(5),Mroot,gc(4),available_sugar,Ascr)
         Froot=Ascr*AsWr*AsT 
         IF(Froot.LT.0.0)Froot=0.0
	   IF(Froot.GT.1.0)Froot=1.0
         Env_r(i)=Froot
! growth rate of roots         	  
         Groot(i)=upt(2)*Froot*prp(3)*Mroot*coef/grc(5)
	   CALL Alloc('root',Mroot*coef,Groot(i),Ps,Su1(i),Su2(i),Su3(i),
     +Mleaf/1000.0,volume,Mroot/1000.0,d13Cps(i),d13CstL(i),d13CstS(i),
     +d13CstR(i),d13CR(i),d13CR(i+1),d13CC(i+1),dDps(i),dDstL(i),
     +dDstS(i),dDstR(i),dDCR(i),dDCR(i+1),dDC(i+1),d18Ops(i),d18OstL(i),
     +d18OstS(i),d18OstR(i),d18OCR(i),d18OCR(i+1),d18OC(i+1))
! reallocation of current sugar and starch 	
	   CALL Redis(Ps,Su1(i),Su2(i),Su3(i),Mleaf/1000.0,volume,
     +	  Mroot/1000.0,0.8,d13Cps(i),dDps(i),d18Ops(i),Su1(i+1),
     +	  Su2(i+1),Su3(i+1),d13CstL(i),d13CstS(i),d13CstR(i),dDstL(i),
     +	  dDstS(i),dDstR(i),d18OstL(i),d18OstS(i),d18OstR(i),FinalPs)

	d13CstL(i+1)=d13CstL(i)
	d13CstS(i+1)=d13CstS(i)
	d13CstR(i+1)=d13CstR(i)
	d13CstL(i)=saved13CstL
	d13CstS(i)=saved13CstS
	d13CstR(i)=saved13CstR
c	d13CC(i+1)=d13CC(i)

	dDstL(i+1)=dDstL(i)
	dDstS(i+1)=dDstS(i)
	dDstR(i+1)=dDstR(i)
	dDstL(i)=savedDstL
	dDstS(i)=savedDstS
	dDstR(i)=savedDstR

	d18OstL(i+1)=d18OstL(i)
	d18OstS(i+1)=d18OstS(i)
	d18OstR(i+1)=d18OstR(i)
	d18OstL(i)=saved18OstL
	d18OstS(i)=saved18OstS
	d18OstR(i)=saved18OstR

	balance(i)=bal-Su1(i+1)-Su2(i+1)-Su3(i+1)-FinalPs+Phot(i)-
     +Rleaf-Rstem-Rroot-Gleaf(i)-Gr(1)-Gr(2)-Gr(3)-Groot(i)

      Su1(i)=saveSu1  
      Su2(i)=saveSu2 
	Su3(i)=saveSu3 
	IF((count.EQ.0.0).AND.(Gr(1).GT.0.0).AND.(i.GT.170))THEN
	  falseday=i
	  count=count+1.0
	ENDIF
      IF(op(12).EQ.2.AND.op(13).EQ.0)THEN
        WRITE(51,'(I5,17F12.3)')i,Asc,AsWl,AsT,
     +            (Gr(k),k=4,12),AscR,AsWr,AsT,ctrcmb(i),ctmcmb(i)
      END IF  
	END DO
C  *************************************************************************     
C  *************************************************************************     
c  *************************  END OF INTERYEAR CYCLE ***********************
C  *************************************************************************     
C  ************************************************************************* 
! tree-ringwidth    
      ringwidth=0.0
      DO i=nc(m)+1,nr(m)
	    ringwidth=ringwidth+ch(8,i) ! Get tree ring width
      ENDDO
      IF(op(12).EQ.2)THEN ! Close files
         CLOSE(45)
         close(19)
         close(29)
      ENDIF
C  ********************************************************************     
CC  OUTPUT DATA FILES   
C  ********************************************************************     
      IF(op(13).EQ.0)THEN
       IF(op(12).EQ.1.OR.op(12).EQ.2)THEN
        OPEN(11,FILE=clfile(1:4)//clfile(7:8)//'P.DAT')
  70    FORMAT(A5,72A12)
        WRITE(11,'(I3,72I12)')(I, I=1,73)
        increment=0  !increment controls repeated print of legend
        WRITE(11,70)'Day','Tem   ','Pre    ','Sm   ','PotTr','Trans ',
     +            'Rest  ','  Reswb','Wab   ',' Ci    ','Phot ','Resp ',
     +            'Gleaf ',
     +            'GRcamb','GRenla','GRmat  ','Groot','SuL  ','SuS   ',
     +            'SuR   ','d13Cps','d13CstL','d13CstS','d13CstR',
     +            'd13CL ','d13CS ','d13CR ','dDps','dDstL','dDstS',
     +            'dDstR','dDCL ','dDCS ','dDCR ','d18Ops','d18OstL',
     +            'd18OstS','d18OstR','d18OCL ','d18OCS ',
     +            'd18OCR ','   Ct  ','  Ctm  ','xleaf..','nr     ',
     +            'nc    ','ne     ','nm     ','dendgr.','dgrmin.',
     +			'dgrmax','So-Si .','stemw','C balan','LimEnvLf',
     +            'LimEnvRt','LimEnvDiv','LimEnvEnl','LimEnvMat',
     +			'd13CCel','dDvap  ','dDPrec  ','dDXw   ','dDLw   ',
     +			'dDCel  ','d18Ovap','d18OPrec','d18OXw ','d18OLw ',
     +			'd18OCel','waterloss','MaxWLoss','DayLength'
       DO i=1,m
       f2=temp(i)
       f3=prec(i)
       f4=sm(i)
       f5=trp(i)/sarea    ! Potential transpiration mm/day
       f6=transp(i)/sarea ! Actual transpiration mm/day
       f7=resist(i)
	 f7a=Resistwb(i)
       f8=wab1(i)   !water absorption
       f9=Ci(i) 
       f10=Phot(i)  ! carbon inside leaf
       f11=Resp(i)
       f12=Gleaf(i)
       f13=GRcamb(i)
       f14=GRenla(i)
       f15=GRmat(i)
       f16=Groot(i)
       f17=Su1(i)
       f18=Su2(i)
       f19=Su3(i)
       f20=d13Cps(i)
       f21=d13CstL(i)
       f22=d13CstS(i)
       f23=d13CstR(i)
       f24=d13CL(i)
       f25=ch(10,i)
       f26=d13CR(i)
       f27=dDps(i)
       f28=dDstL(i)
       f29=dDstS(i)
       f30=dDstR(i)
       f31=dDCL(i)
       f32=ch(11,i)
       f33=dDCR(i)
	 f34=d18Ops(i)
       f35=d18OstL(i)
	 f36=d18OstS(i)
	 f37=d18OstR(i)
	 f38=d18OCL(i)
	 f39=ch(12,i)
	 f40=d18OCR(i)
	 f41=Ctrcmb(i)
	 f42=Ctmcmb(i)
	 f43=xleaf(i) 
	 f44=nr(i)
	 f45=nc(i)
	 f46=ne(i)
	 f47=nm(i)
	 f48=dendgr(i)
	 f49=dgrmin(i)
	 f50=dgrmax(i)
	 f51=f10-f11-f12-f13-f14-f15-f16
	 f52=stemw(i)
	 f53=balance(i)
       f54=Env_l(i)
	 f55=Env_r(i)
       f56=Env_c(i)
       f57=Env_e(i)
       f58=Env_m(i)
	 f59=d13CC(i)
	 f60=dDvap(i)
	 f61=dDprec(i)
	 f62=dDXw(i)
	 f63=dDLw(i)
	 f64=dDC(i)
	 f65=d18Ovap(i)
	 f66=d18Oprec(i)
	 f67=d18OXw(i)
	 f68=d18OLw(i)
	 f69=d18OC(i)
	 f70=waterloss(i)
	 f71=MaxWatLoss(i)
	 f72=Dlen(i)
	
        WRITE(11,50)i,f2,f3,f4,f5,f6,f7,f7a,f8,f9,f10,f11,f12,f13,f14,
     +  f15,f16,f17,f18,f19,f20,f21,f22,f23,f24,f25,
     +  f26,f27,f28,f29,f30,f31,f32,f33,f34,f35,f36,f37,f38,f39,f40,f41,
     +  f42,f43,f44,f45,f46,f47,f48,f49,f50,f51,f52,f53,f54,f55,f56,f57,
     +  f58,f59,f60,f61,f62,f63,f64,f65,f66,f67,f68,f69,f70,f71,f72
 50     FORMAT(I5,73F12.3)
        END DO
        CLOSE(11) ! file *P.dat
       END IF
      END IF
! Dendrograph file (data)
      IF(op(12).EQ.2.OR.op(13).EQ.0)THEN
        OPEN(11,FILE=clfile(1:4)//clfile(7:8)//'Dr.DAT')
        WRITE(11,'(I3,8I12)')(J, J=1,9)
        WRITE(11,'('' Day'',''  dendgr(i) '',''  dgrmin(i) '',
     +     ''  dgrmax(i) '',''        MIN '',''       MAX  '',
     +     ''  Min Conc  '',''  Max Conc  '',''    Scaler  '')') 
! the change of sapwood water contents from min to max
! correspond 50 mkm
! at stemw = max the radius is maximal
        DO i=1,m ! FOR YEAR
         dMINrad=-(p(42)-dgrmin(i))/(p(42)-p(41))*1000.0
         dMINrad=dendgr(i)+(dMINrad*p(45))
         dMAXrad=-(p(42)-dgrmax(i))/(p(42)-p(41))*1000.0
         dMAXrad=dendgr(i)+(dMAXrad*p(45))
         WRITE(11,'(i5,8f12.3)')i,dendgr(i),dgrmin(i),dgrmax(i),dMINrad,
     +                            dMAXrad,p(41),p(42),p(45)
        ENDDO
	  CLOSE(11) ! close dendrograph file
      END IF
! Cambium dynamic for year
         jas=0              ! Parameter for writing file
      IF(op(12).EQ.2.AND.op(13).EQ.0)THEN
        OPEN(14,FILE=clfile(1:4)//clfile(7:8)//'C.DAT')
        WRITE(14,'(A15,F6.2)')'ring=',nr(m)
        WRITE(14,'(13A8)')' Cell# ',' div 1 ',
     +      ' T enl ','dist i ',' T mat ',' T dead',' iE Size ',
     +      'Density',' Size  ',' Wall  ',' d13C  ','  dD   ',
     +      ' d18O  '
	count=0.0
	d13CLatew=0.0
	dDLatew=0.0
	d18OLatew=0.0
	d13CPre2=0.0
	dDPre2=0.0
	d18OPre2=0.0
	d13CPre1=0.0
	dDPre1=0.0
	d18OPre1=0.0
	FalseLw=0.0
	Pre2=0.0
        DO i=1,nr(m)
		ch(7,i)=((ch(8,i)*b3)-((b3-(ch(9,i)*2))*(ch(8,i)-
     +			(ch(9,i)*2))))*1200/(ch(8,i)*b3) !Density Calculation
          WRITE(14,'(I8,12F8.2)')i,(ch(j,i),j=1,12)
c-------------------------------------------------------------------------
c  Locate position of earlywood (Pre1-2 boundary) and latewood from change 
c  in density of false latewood cells.
c-------------------------------------------------------------------------
		IF((i.GT.1).AND.(ch(1,i).LE.Falseday).AND.(count.EQ.0.0))THEN
			FalseLw=i
			count=1.0
c 		DifDen(i)=ch(7,i)-ch(7,(i-1))
c			IF(i.GT.3)THEN
c			   IF((DifDen(i).LE.-12.0).AND.(DifDen(i-1).GT.-3.0)
c     +				.AND.(count.LT.2))THEN
c				  count=count+1
c				  IF(count.EQ.2)THEN
c					FalseLw=i
					Pre2=INT(((nr(m)-FalseLw)/2)+FalseLw)
					Lw=(SUM(ch(8,1:FalseLw))/ringwidth)*100
					IF(Lw.GT.100)Lw=100
					Ew=100-Lw
c				  ENDIF
c			   ENDIF
c			ENDIF
		ENDIF

c		Lw=((0.5164*(ringwidth)-2.685)/ringwidth)*100
c		Ew=100-Lw
c		Lw=0.5164*(ringwidth)-2.685
c		Ew=ringwidth-Lw
		IF(i.GT.1)THEN
		  WallAr(i)=((ch(8,i)*b3)-((b3-(ch(9,i)*2))*(ch(8,i)-
     +			 (ch(9,i)*2))))
		  WallArea=WallArea+WallAr(i)
			IF(i.EQ.FalseLw)THEN
				LwWallAr=WallArea
				WallArea=0.0
				DO n=1,FalseLw
				  d13CLatew=d13CLatew+ch(10,n)*(WallAr(n)/LwWallAr)
				  dDLatew=dDLatew+ch(11,n)*(WallAr(n)/LwWallAr)
				  d18OLatew=d18OLatew+ch(12,n)*(WallAr(n)/LwWallAr)
				END DO
			ELSEIF(i.EQ.Pre2)THEN
				Pre2WallAr=WallArea
				WallArea=0.0
				DO n=(FalseLw+1),Pre2
				  d13CPre2=d13CPre2+ch(10,n)*(WallAr(n)/Pre2WallAr)
				  dDPre2=dDPre2+ch(11,n)*(WallAr(n)/Pre2WallAr)
				  d18OPre2=d18OPre2+ch(12,n)*(WallAr(n)/Pre2WallAr)
				END DO
			ELSEIF(i.EQ.nr(m))THEN
				Pre1WallAr=WallArea
				WallArea=0.0
				DO n=(Pre2+1),nr(m)
				  d13CPre1=d13CPre1+ch(10,n)*(WallAr(n)/Pre1WallAr)
				  dDPre1=dDPre1+ch(11,n)*(WallAr(n)/Pre1WallAr)
				  d18OPre1=d18OPre1+ch(12,n)*(WallAr(n)/Pre1WallAr)
				END DO
			ENDIF
		ENDIF
        END DO
        CLOSE(14) ! cambium dynamics
      END IF
! Annual data
      AnPhot=  SUM(Phot)
      AnRes=   SUM(Resp)
      AnGrleaf=SUM(Gleaf)
      AnGrcamb=SUM(GRcamb)
      AnGrenla=SUM(GRenla)
      AnGrmat= SUM(GRmat)
      AnGrroot=SUM(Groot)
      xibeg=ibeg 
      IF(op(12).EQ.2.AND.op(13).EQ.0)THEN
        WRITE(53,51)ig,AnPhot,AnRes,AnGrleaf,AnGrcamb,AnGrenla,AnGrmat,
     +    AnGrroot,Su1(m),Su2(m),Su3(m),d13CL(m),ch(10,m),d13CR(m),
     +    dDCL(m),ch(11,m),dDCR(m),d18OCL(m),ch(10,m),d18OCR(m),
     +    nr(m),ringwidth,Mleaf,Mstem,Volume,Mroot,xibeg,FalseLw,Lw,Ew,
     +    d13Cpre1,d13CPre2,d13CLatew,dDPre1,dDPre2,dDLatew,
     +    d18OPre1,d18OPre2,d18OLatew
	  count=0.0
      END IF      
 51   FORMAT(I5,38F12.2)
c      IF (op(4).EQ.0) GOTO 202 
C  *************************************************************************     
CC  Parameters initialized for use in calculating statistics
C  *************************************************************************     
      CHREST(JJ)=0.
      IF(op(1).GT.1.AND.ig.GE.op(29).AND.ig.LE.op(30))THEN
        JJJ=JJJ+1
        EstN(jjj)=0.   ! Ring Size for Estimate set to zero
        EstW(jjj)=0.   ! Cell numbers for Estimate set to zero
      ENDIF
C     End of parameters used in calculating statistics
C  *************************************************************************     
CC  Sums for statistics of annual rings
C  *************************************************************************     
      knr=nr(m)
	knc=nc(m)
      J=nr(m)
C  REVERSE ARRAY     
      J=nr(m)-nc(m)
      DO i=knc+1,knr
         sizerev(j)=ch(8,i) ! Size of each Estimated cell Reversed
         IF(op(1).GT.1.AND.ig.GE.op(29).AND.ig.LE.op(30))THEN
           EstN(jjj)=Estn(jjj)+ch(8,i) !Sum Cell Sizes over Ring Est
         Endif
         CHREST(JJ)=CHREST(JJ)+ch(8,i)
         wallrev(j)=ch(9,i)  ! wall thickness in each cell Estimate ???
	   J=J-1      
      END DO
      CLOSE(60)
C  *************************************************************************     
CC  End of Sums for statistics of annual rings
C  *************************************************************************     
C  *************************************************************************     
CC  Sums for number of cells in estimated annual rings
C  *************************************************************************     
      IF(op(1).GT.1.AND.ig.GE.op(29).AND.ig.LE.op(30))THEN
        Estw(JJJ)=knr
      ENDIF              ! number of cells in ring
C  *************************************************************************     
CC  File name of cell measurements *.CRN   No longer need *.MTR files 
C  *************************************************************************     
      IF(op(1).GT.1.AND.ig.GE.op(29).AND.ig.LE.op(30))THEN
100     IF(op(19).EQ.0)THEN
C  *************************************************************************     
C The following format is for Alex's measurements
C  *************************************************************************     
C Format for Chiricahua Data
c         Read(40,'(I5,I6,F9.1,8X,F8.1,5X,2F8.2,F5.0)')IYEAR,
c     .   icln,realN(JJJ),realW(JJJ),MSWIDTH,MSWALL,REP
C Format for Santa Catalina Study area
        Read(40,'(I5,I6,F9.1,7X,F7.1,7X,2F11.2,F5.0,8X,1000(F8.1,F5.1))
     .      ',err=99)IYEAR,ICLN,realN(JJJ),realW(JJJ),MSWIDTH,
     .       MSWALL,REP,(sizz(i),wall(i),
     .       i=1,ICLN)
         nreal=icln
C        Reading Statistical measurements for replicates
C        Year,Number of cells, Sum of cell width, Sum of Wall Thickness,
C        Mean Square of Widths among replicates, Mean Square of Thicknesses
C        among replicates, Number of replicates
       ELSE 
C  *************************************************************************     
c The following format is for SilviScan data Needs revision with version 70
C  *************************************************************************     
         Read(40,'(I5,5X,I8,F8.2,8X,F8.2,8X,2F8.2,F10.0)')IYEAR,
     .   icln,realN(JJ),realW(JJ),MSWIDTH,MSWALL,REP
         MSWIDTH=MSWIDTH*100
         MSWALL=MSWALL*100
       ENDIF
         IF(IYEAR.NE.BEGYEAR+JJ-1)GO TO 100 !Read the next file
         realnos(JJJ)=icln
      ENDIF
C  *************************************************************************     
C  Skips around plot routine if no plots to be generated to 401
C  *************************************************************************     
401   CONTINUE ! To here for non graphics runs
      IF(op(1).gt.1)THEN ! If independent (actual) measurements availabl
c        If(knr.lt.2.or.chr(jj).EQ.0)THEN
        If(knr.lt.2)THEN
          ICHRMS(JJ)=0  ! Sets ICHRMS to zero if it is missing ring
        ELSE  ! Independent data not available
          ICHRMS(JJ)=1  ! Sets ICHRMS to one if it is NOT a missing ring
        ENDIF
        IF(icln.LT.2.OR.knr.LT.2)THEN
C  *************************************************************************     
CC  Checks if ring any one of the pair is missing
C  *************************************************************************     
          IF(op(1).GT.1.AND.ig.GE.op(29).AND.ig.LE.op(30))
     +    MISSRING(JJJ)=0  ! MISSRING set to 0
          GOTO 300 ! skips around next IF THEN if ring missing
        ENDIF
      ENDIF
      IF(op(1).GT.1.AND.ig.GE.op(29).AND.ig.LE.op(30))THEN
        MISSRING(JJJ)=1 ! Neither Ring Pair is missing MISSRING set to 1
        IF(op(8).EQ.0)THEN  !Data not normalized, normalize them
C  *************************************************************************     
CC  Normalizes cell sizes and wall thicknesses to number in actual measurements
C  *************************************************************************     
          CALL NORMAL(knr,sizerev,nreal)
          IF(mswall.GT.0)CALL NORMAL(knr,wallrev,nreal)
        ENDIF
      ENDIF
201   IF(op(1).GT.1.AND.ig.GE.op(29).AND.ig.LE.op(30))THEN 
C  *************************************************************************     
CC  Calculates sums and sums of squares (will not do if one of rings missing)
C  *************************************************************************     
c      If(op(13).eq.1)write(*,'('' Call Extra 1 '',i5)')iyear
        CALL EXTRA1(JJ,op,iyear,jjj)
      ENDIF
300   CONTINUE
C  *************************************************************************     
CC Calculation of the conditions for next year---------------------------
C  *************************************************************************     
202   CONTINUE
      READ(clfile(5:8),'(I4)')ig
      JJ=JJ+1
      IF(ig.LT.endyear)THEN
! soil and stem moisture
         sm(1)=  sm(m)
	   stemw(1)=stemw(m+1)
! dendrograph estimate
         dendgr(1)=dendgr(m)
! carbohydrate storage and its isotope composition
         Su1(1)=Su1(m)
         Su2(1)=Su2(m)
         Su3(1)=Su3(m)
	   d13CstL(1)=d13CstL(m) ! d13C of stored sucrose in leaf
	   d13CstS(1)=d13CstS(m) ! d13C of stored sucrose in stem
	   d13CstR(1)=d13CstR(m) ! d13C of stored sucrose in root
	   dDstL(1)=dDstL(m)
	   dDstS(1)=dDstS(m)
	   dDstR(1)=dDstR(m)
	   d18OstL(1)=d18OstL(m)
	   d18OstS(1)=d18OstS(m)
	   d18OstR(1)=d18OstR(m)
! isotope composition in initial material of foliage,stem,root
         d13CL(1)=d13CL(m)          
         d13CS(1)=ch(10,1)          
         d13CR(1)=d13CR(m)
         dDCL(1)=dDCL(m)          
         dDCS(1)=ch(11,1)          
         dDCR(1)=dDCR(m)
         d18OCL(1)=d18OCL(m)          
         d18OCS(1)=ch(12,1)          
         d18OCR(1)=d18OCR(m)
! isotope composition in initial soil/xylem water and leaf water
	   d18OXw(1)=d18OXw(m)
	   dDXw(1)=dDXw(m) 
! cambium cells 
         num(1)=num(2)                  
	   nr(1)=nc(m)
	   nc(1)=nc(m)
	   me=0
	   nm=0
         DO i=knc+1,1000
            state(i)=' '
	      DO j=1,12
	         ch(j,i)=0
            END DO
         END DO
	DO i=1,100
	   k=nc(1) 
	   IF(Correct(2,i).LE.k.AND.Correct(2,i).GT.0.0)THEN
           DCorrect(1,Correct(2,i))=0
	     DCorrect(2,Correct(2,i))=Correct(2,i)
	     DCorrect(3,Correct(2,i))=Correct(3,i)
         ENDIF
	   Correct(1,i)=0
	   Correct(2,i)=0
	   Correct(3,i)=0
	ENDDO
	DO i=1,k
	   Correct(1,i)=DCorrect(1,i)
	   Correct(2,i)=DCorrect(2,i)
	   Correct(3,i)=DCorrect(3,i)
      END DO
         ig=ig+1
         jyear=ig
         WRITE(clfile(5:8),'(I4)')ig
! to next year
         GOTO 20
      END IF
C  *************************************************************************     
C 122  CONTINUE !Skips plotting Op(11).EQ.0 and Save Screen Op(4).EQ.0
C **************************************************************************
c  NOW CALCULATE NEW CROWN, HEIGHT AND MASSES. 
C **************************************************************************
C      IF(op(13).EQ.0)THEN  ! If not iterating
C        IF(op(5).EQ.1)THEN
C	    WRITE(*,*) 'Press Enter key to continue'
c	    pause ' ' !Pause so screen can be read (Use if CONTSHOW not working)
C        ENDIF
c        If(op(5).EQ.2)CALL ContShow() !Windows 95? Message Box "OK" to continue
C      ENDIF
C  *************************************************************************     
CC Set options for ending the program
C  *************************************************************************     
c      IF(OP(11).EQ.1)i=SETEXITQQ(QWIN$EXITPERSIST)
      CLOSE(37)
      CLOSE(40)
        IF(op(1).lt.2)THEN
         CLOSE (3)
         GOTO 90 !Exit if no Independent measurements 
        ENDIF
      IF(JJJ.LT.3)GOTO 93 ! If less than 3 observations 
      JJ=JJ-1
C  *************************************************************************     
CC Calculate statistics and Iterate if indicated
C  *************************************************************************     
c      If(op(13).eq.1)write(*,'('' Call Extra2 '')')
c      IF(NITI.EQ.9.OR.NITI.EQ.18)CALL clearscreen($gclearscreen)
      CALL EXTRA2(IIGO,IERR,ITI,NITI,DELTA,MO,LO,VARNEW,OP,NOVAR,
     +ITIF,JJJ,JJ,begyear,endyear,clfile,srz)
      IF(JJ.GT.1.AND.op(1).GE.3)THEN
        IF(op(13).EQ.1.AND.op(16).LT.6)GOTO 196
C  *************************************************************************     
CC Call chronology after iteration finished so can run with changes
C  *************************************************************************     
        CALL CHRON(op,IDCRN,NCHYR,BEGYEAR,ENDYEAR,srz,ITI,NITI,DELTA,MO,
     +  LO,VARNEW,NOVAR,ITIF,IIGO,IERR,CLFILE,JJ)
196     CONTINUE
      ENDIF
      jjj=0
      GOTO(90,94,98,400,90),IIGO
90    txterr=' Thank you for your interest! '
      GOTO 27
91    txterr=' Cannot open ITERATE>OUT'
      GOTO 27
93    txterr=' Less than 3 observations, Statistics not calculated'
      GOTO 27
94    write(*,'(''Iterated Variable Output Out of Range Error Number '',
     +I2)')ierr
      GOTO 27
95    write(*,'(''Iterated Variable Input Out of Range Error Number '',
     +I2)')ierr
      GOTO 27
98    write(*,'('' Iteration terminated abnormally'')')
      GOTO 27
 6    txterr=' No Actual Chronology File *.CRN'
      GOTO 27
 10   txterr=' File trg62.INF or Mcconst.cst'
      GOTO 27
 13   txterr=' No file trg61.PAR'
      GOTO 27
 113  txterr=' No initial data file trg2000.IO'
      GOTO 27
 114  txterr=' Attemted to open Statistics File'
      GOTO 27
999   txterr=' Attempted to open independent data (*.crn) file'
      GOTO 27
9999  txterr=' No file piso.par  '
 15   WRITE(*,*)' Error in Clim data file'
 99   txterr=' Error in reading independent cell measurements '  
 27   CONTINUE
      WRITE(*,*)txterr  
      CLOSE(52)
      CLOSE(33)
      CLOSE(40)
      CLOSE(37)
      CLOSE(19)
      CLOSE(29)
      CLOSE(30)
! ---------------------------------------------------------------------
!                          End of calculation message
! ---------------------------------------------------------------------
      CLOSE(53) ! annual output data
	IF(op(13).EQ.0)WRITE(*,'('' Calculations are finished.''\
     + '' First year:'',I6,''  Last year:'',I6)')begyear,ig
      END

